#pragma once

namespace PM24084R {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Media;
	using namespace System::IO::Ports;
	
	/// <summary>
	/// MyForm Kn
	/// </summary>
	public ref class MyForm : public System::Windows::Forms::Form
	{
	public:
		MyForm(void)
		{
			InitializeComponent();
			//
			//TODO:  b[Jغc禡{X
			//
		}

	protected:
		/// <summary>
		/// MϥΤ귽C
		/// </summary>
		~MyForm()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::StatusStrip^  statusStrip;
	protected:
	private: System::Windows::Forms::ToolStripStatusLabel^  tss_Status;
	private: System::Windows::Forms::ToolStripStatusLabel^  tss_BaudRate;
	private: System::Windows::Forms::ToolStripStatusLabel^  tss_REV;
	private: System::Windows::Forms::Timer^  timer;
	private: System::IO::Ports::SerialPort^  serialPort;
	private: System::Windows::Forms::Panel^  pn_Port;
	private: System::Windows::Forms::Button^  btn_Connect;
	private: System::Windows::Forms::ComboBox^  cbb_PortNo;
	private: System::Windows::Forms::Label^  lb_PortNo;
	private: System::Windows::Forms::RichTextBox^  richTextBox;
	private: System::Windows::Forms::Label^  lb_L1;
	private: System::Windows::Forms::GroupBox^  gpb_L1;
	private: System::Windows::Forms::Panel^  pn_L1_Output;
	private: System::Windows::Forms::Label^  lb_L1_MIN;
	private: System::Windows::Forms::Label^  lb_L1_MAX;
	private: System::Windows::Forms::TrackBar^  tkb_L1_Output;
	private: System::Windows::Forms::Label^  lb_L1_PC;
	private: System::Windows::Forms::Label^  lb_L1_PCV;
	private: System::Windows::Forms::NumericUpDown^  nud_L1_Output;
	private: System::Windows::Forms::Label^  lb_L1_Output;
	private: System::Windows::Forms::Panel^  pn_L1_Set;
	private: System::Windows::Forms::Button^  btn_L1;
	private: System::Windows::Forms::Panel^  pn_L1_LED;
	private: System::Windows::Forms::CheckBox^  ckb_L1_EXT;
	private: System::Windows::Forms::ComboBox^  cbb_L1_MaxC;
	private: System::Windows::Forms::Label^  lb_L1_MaxC;
	private: System::Windows::Forms::Label^  lb_L2;
	private: System::Windows::Forms::GroupBox^  gpb_L2;
	private: System::Windows::Forms::Panel^  pn_L2_Output;
	private: System::Windows::Forms::Label^  lb_L2_MIN;
	private: System::Windows::Forms::Label^  lb_L2_MAX;
	private: System::Windows::Forms::TrackBar^  tkb_L2_Output;
	private: System::Windows::Forms::Label^  lb_L2_PC;
	private: System::Windows::Forms::Label^  lb_L2_PCV;
	private: System::Windows::Forms::NumericUpDown^  nud_L2_Output;
	private: System::Windows::Forms::Label^  lb_L2_Output;
	private: System::Windows::Forms::Panel^  pn_L2_Set;
	private: System::Windows::Forms::Button^  btn_L2;
	private: System::Windows::Forms::Panel^  pn_L2_LED;
	private: System::Windows::Forms::CheckBox^  ckb_L2_EXT;
	private: System::Windows::Forms::ComboBox^  cbb_L2_MaxC;
	private: System::Windows::Forms::Label^  lb_L2_MaxC;
	private: System::Windows::Forms::Label^  lb_L3;
	private: System::Windows::Forms::GroupBox^  gpb_L3;
	private: System::Windows::Forms::Panel^  pn_L3_Output;
	private: System::Windows::Forms::Label^  lb_L3_MIN;
	private: System::Windows::Forms::Label^  lb_L3_MAX;
	private: System::Windows::Forms::TrackBar^  tkb_L3_Output;
	private: System::Windows::Forms::Label^  lb_L3_PC;
	private: System::Windows::Forms::Label^  lb_L3_PCV;
	private: System::Windows::Forms::NumericUpDown^  nud_L3_Output;
	private: System::Windows::Forms::Label^  lb_L3_Output;
	private: System::Windows::Forms::Panel^  pn_L3_Set;
	private: System::Windows::Forms::Button^  btn_L3;
	private: System::Windows::Forms::Panel^  pn_L3_LED;
	private: System::Windows::Forms::CheckBox^  ckb_L3_EXT;
	private: System::Windows::Forms::ComboBox^  cbb_L3_MaxC;
	private: System::Windows::Forms::Label^  lb_L3_MaxC;
	private: System::Windows::Forms::Label^  lb_L4;
	private: System::Windows::Forms::GroupBox^  gpb_L4;
	private: System::Windows::Forms::Panel^  pn_L4_Output;
	private: System::Windows::Forms::Label^  lb_L4_MIN;
	private: System::Windows::Forms::Label^  lb_L4_MAX;
	private: System::Windows::Forms::TrackBar^  tkb_L4_Output;
	private: System::Windows::Forms::Label^  lb_L4_PC;
	private: System::Windows::Forms::Label^  lb_L4_PCV;
	private: System::Windows::Forms::NumericUpDown^  nud_L4_Output;
	private: System::Windows::Forms::Label^  lb_L4_Output;
	private: System::Windows::Forms::Panel^  pn_L4_Set;
	private: System::Windows::Forms::Button^  btn_L4;
	private: System::Windows::Forms::Panel^  pn_L4_LED;
	private: System::Windows::Forms::CheckBox^  ckb_L4_EXT;
	private: System::Windows::Forms::ComboBox^  cbb_L4_MaxC;
	private: System::Windows::Forms::Label^  lb_L4_MaxC;
	private: System::Windows::Forms::Label^  lb_PWR_ERR;
	private: System::Windows::Forms::GroupBox^  gpb_ON_OFF;
	private: System::Windows::Forms::ComboBox^  cbb_SYNC_EN;
	private: System::ComponentModel::IContainer^  components;

	private:
		/// <summary>
		/// ]puһݪܼơC
		/// </summary>

		/* ################################################################## */
		/* Definitions                                                        */
		/* ################################################################## */
		// Command =============================================================
		#define CMD_READ_DATA           0x80            // Command: Read Data (Ū)
		#define CMD_SYNC_EN             0x70            // Command: SYNC Enable (PBP)
		#define CMD_L1_SET              0x91            // Command: L1 Set (L1]w)
		#define CMD_L2_SET              0x92            // Command: L2 Set (L2]w)
		#define CMD_L3_SET              0x93            // Command: L3 Set (L3]w)
		#define CMD_L4_SET              0x94            // Command: L4 Set (L4]w)
		#define CMD_L1_OUTPUT           0xA1            // Command: L1 Output (L1Xqy)
		#define CMD_L2_OUTPUT           0xA2            // Command: L2 Output (L2Xqy)
		#define CMD_L3_OUTPUT           0xA3            // Command: L3 Output (L3Xqy)
		#define CMD_L4_OUTPUT           0xA4            // Command: L4 Output (L4Xqy)
		#define CMD_L1_ON_OFF           0xC1            // Command: L1 ON/OFF
		#define CMD_L2_ON_OFF           0xC2            // Command: L2 ON/OFF
		#define CMD_L3_ON_OFF           0xC3            // Command: L3 ON/OFF
		#define CMD_L4_ON_OFF           0xC4            // Command: L4 ON/OFF

		// ACK_State ===========================================================
		#define AS_FAILED               0x80            // bit7 RO檬A    : 0=\, 1=
		#define AS_SYNC_EN1             0x40            // bit6~5 ON/OFFPBP: 00=ASYNC (ӧO)
		#define AS_SYNC_EN0             0x20            //                        01=SYNC2 (L1~L2PB)
														//                        10=SYNC3 (L1~L3PB)
														//                        11=SYNC4 (L1~L4PB)
		#define AS_PWR_ERR              0x10            // bit4 qA        : 0=OK, 1=Error
		#define AS_L4_ERR               0x08            // bit3 L4A          : 0=OK, 1=Error
		#define AS_L3_ERR               0x04            // bit2 L3A          : 0=OK, 1=Error
		#define AS_L2_ERR               0x02            // bit1 L2A          : 0=OK, 1=Error
		#define AS_L1_ERR               0x01            // bit0 L1A          : 0=OK, 1=Error

		// SYNC_EN =============================================================
		#define ASYNC                   0               // ASYNC (ӧO)
		#define SYNC2                   1               // SYNC2 (L1~L2PB)
		#define SYNC3                   2               // SYNC3 (L1~L3PB)
		#define SYNC4                   3               // SYNC4 (L1~L4PB)

		// Lx_Set ==============================================================
		#define SET_EXT_CTRL            0x02            // bit1 ~ON/OFF: 0=Disable, 1=Enable
		#define SET_ON_OFF              0x01            // bit0 ON/OFF        : 0=OFF, 1=ON

		// =====================================================================
		#define Lines_Max               256             // ̤j
		#define ACK_TO                  10              // ^O, 500ms (10 * 50ms)
		#define AUTO_TMR                60              // ۰ʸ߰ݭp, 3sec (60 * 50ms)

		/* ################################################################## */
		/* Globals                                                            */
		/* ################################################################## */
		String^ MODEL = "PM-24084R ";                   // Model: PM-24084R
		UInt16 Line_No = 0;                             // ƽs
		UInt16 Line_CTR = 0;                            // ƭp
		array<String^>^ PortNo;                         // s
		bool PORT_Flag = false;                         // PORT X
		bool READ_Flag = false;                         // READ X
		Byte ACK_TO_CTR = 0;                            // ^Oɭp
		Byte ACK_State = 0x00;                          // ^A
		Byte Auto_CTR = 0;                              // ۰ʸ߰ݭp
		Byte Flash_CTR = 0;                             // {{p
		array<int>^ MaxCurrent = gcnew array<int>(4);   // ̤jqy

		// TX ==================================================================
		bool TX_Flag = false;                           // TX X
		array<Byte>^ TX_Packet = gcnew array<Byte>(7);  // TX ʥ]
		Byte TX_CMD = 0;                                // TX RO
		Byte TX_CTR = 0;                                // TX ǰe

		// RX ==================================================================
		bool RX_Flag = false;                           // RX X
		array<Byte>^ RX_Packet = gcnew array<Byte>(17); // RX ʥ]
		Byte RX_Index = 0;                              // RX ʥ]
		Byte RX_Length = 0;                             // RX ʥ]

		// SYNC ================================================================
		bool SYNC_EN_CHG = false;                       // SYNC Enable w
		Byte SYNC_EN = ASYNC;                           // SYNC Enable

		// L1 ==================================================================
		bool L1_Set_CHG = false;                        // L1 Set w
		bool L1_Output_CHG = false;                     // L1 Output w
		bool L1_ON_OFF_CHG = false;                     // L1 ON/OFF w
		Byte L1_Set = 0;                                // L1 ]w
		int L1_Output = 0;                              // L1 X

		// L2 ==================================================================
		bool L2_Set_CHG = false;                        // L2 Set w
		bool L2_Output_CHG = false;                     // L2 Output w
		bool L2_ON_OFF_CHG = false;                     // L2 ON/OFF w
		Byte L2_Set = 0;                                // L2 ]w
		int L2_Output = 0;                              // L2 X

		// L3 ==================================================================
		bool L3_Set_CHG = false;                        // L3 Set w
		bool L3_Output_CHG = false;                     // L3 Output w
		bool L3_ON_OFF_CHG = false;                     // L3 ON/OFF w
		Byte L3_Set = 0;                                // L3 ]w
		int L3_Output = 0;                              // L3 X

		// L4 ==================================================================
		bool L4_Set_CHG = false;                        // L4 Set w
		bool L4_Output_CHG = false;                     // L4 Output w
		bool L4_ON_OFF_CHG = false;                     // L4 ON/OFF w
		Byte L4_Set = 0;                                // L4 ]w
		int L4_Output = 0;                              // L4 X

#pragma region Windows Form Designer generated code
		/// <summary>
		/// ]pu䴩һݪk - ФŨϥε{Xs边ק
		/// oӤkeC
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			this->statusStrip = (gcnew System::Windows::Forms::StatusStrip());
			this->tss_Status = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			this->tss_BaudRate = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			this->tss_REV = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			this->timer = (gcnew System::Windows::Forms::Timer(this->components));
			this->serialPort = (gcnew System::IO::Ports::SerialPort(this->components));
			this->pn_Port = (gcnew System::Windows::Forms::Panel());
			this->btn_Connect = (gcnew System::Windows::Forms::Button());
			this->cbb_PortNo = (gcnew System::Windows::Forms::ComboBox());
			this->lb_PortNo = (gcnew System::Windows::Forms::Label());
			this->richTextBox = (gcnew System::Windows::Forms::RichTextBox());
			this->lb_L1 = (gcnew System::Windows::Forms::Label());
			this->gpb_L1 = (gcnew System::Windows::Forms::GroupBox());
			this->pn_L1_Output = (gcnew System::Windows::Forms::Panel());
			this->lb_L1_MIN = (gcnew System::Windows::Forms::Label());
			this->lb_L1_MAX = (gcnew System::Windows::Forms::Label());
			this->tkb_L1_Output = (gcnew System::Windows::Forms::TrackBar());
			this->lb_L1_PC = (gcnew System::Windows::Forms::Label());
			this->lb_L1_PCV = (gcnew System::Windows::Forms::Label());
			this->nud_L1_Output = (gcnew System::Windows::Forms::NumericUpDown());
			this->lb_L1_Output = (gcnew System::Windows::Forms::Label());
			this->pn_L1_Set = (gcnew System::Windows::Forms::Panel());
			this->btn_L1 = (gcnew System::Windows::Forms::Button());
			this->pn_L1_LED = (gcnew System::Windows::Forms::Panel());
			this->ckb_L1_EXT = (gcnew System::Windows::Forms::CheckBox());
			this->cbb_L1_MaxC = (gcnew System::Windows::Forms::ComboBox());
			this->lb_L1_MaxC = (gcnew System::Windows::Forms::Label());
			this->lb_L2 = (gcnew System::Windows::Forms::Label());
			this->gpb_L2 = (gcnew System::Windows::Forms::GroupBox());
			this->pn_L2_Output = (gcnew System::Windows::Forms::Panel());
			this->lb_L2_MIN = (gcnew System::Windows::Forms::Label());
			this->lb_L2_MAX = (gcnew System::Windows::Forms::Label());
			this->tkb_L2_Output = (gcnew System::Windows::Forms::TrackBar());
			this->lb_L2_PC = (gcnew System::Windows::Forms::Label());
			this->lb_L2_PCV = (gcnew System::Windows::Forms::Label());
			this->nud_L2_Output = (gcnew System::Windows::Forms::NumericUpDown());
			this->lb_L2_Output = (gcnew System::Windows::Forms::Label());
			this->pn_L2_Set = (gcnew System::Windows::Forms::Panel());
			this->btn_L2 = (gcnew System::Windows::Forms::Button());
			this->pn_L2_LED = (gcnew System::Windows::Forms::Panel());
			this->ckb_L2_EXT = (gcnew System::Windows::Forms::CheckBox());
			this->cbb_L2_MaxC = (gcnew System::Windows::Forms::ComboBox());
			this->lb_L2_MaxC = (gcnew System::Windows::Forms::Label());
			this->lb_L3 = (gcnew System::Windows::Forms::Label());
			this->gpb_L3 = (gcnew System::Windows::Forms::GroupBox());
			this->pn_L3_Output = (gcnew System::Windows::Forms::Panel());
			this->lb_L3_MIN = (gcnew System::Windows::Forms::Label());
			this->lb_L3_MAX = (gcnew System::Windows::Forms::Label());
			this->tkb_L3_Output = (gcnew System::Windows::Forms::TrackBar());
			this->lb_L3_PC = (gcnew System::Windows::Forms::Label());
			this->lb_L3_PCV = (gcnew System::Windows::Forms::Label());
			this->nud_L3_Output = (gcnew System::Windows::Forms::NumericUpDown());
			this->lb_L3_Output = (gcnew System::Windows::Forms::Label());
			this->pn_L3_Set = (gcnew System::Windows::Forms::Panel());
			this->btn_L3 = (gcnew System::Windows::Forms::Button());
			this->pn_L3_LED = (gcnew System::Windows::Forms::Panel());
			this->ckb_L3_EXT = (gcnew System::Windows::Forms::CheckBox());
			this->cbb_L3_MaxC = (gcnew System::Windows::Forms::ComboBox());
			this->lb_L3_MaxC = (gcnew System::Windows::Forms::Label());
			this->lb_L4 = (gcnew System::Windows::Forms::Label());
			this->gpb_L4 = (gcnew System::Windows::Forms::GroupBox());
			this->pn_L4_Output = (gcnew System::Windows::Forms::Panel());
			this->lb_L4_MIN = (gcnew System::Windows::Forms::Label());
			this->lb_L4_MAX = (gcnew System::Windows::Forms::Label());
			this->tkb_L4_Output = (gcnew System::Windows::Forms::TrackBar());
			this->lb_L4_PC = (gcnew System::Windows::Forms::Label());
			this->lb_L4_PCV = (gcnew System::Windows::Forms::Label());
			this->nud_L4_Output = (gcnew System::Windows::Forms::NumericUpDown());
			this->lb_L4_Output = (gcnew System::Windows::Forms::Label());
			this->pn_L4_Set = (gcnew System::Windows::Forms::Panel());
			this->btn_L4 = (gcnew System::Windows::Forms::Button());
			this->pn_L4_LED = (gcnew System::Windows::Forms::Panel());
			this->ckb_L4_EXT = (gcnew System::Windows::Forms::CheckBox());
			this->cbb_L4_MaxC = (gcnew System::Windows::Forms::ComboBox());
			this->lb_L4_MaxC = (gcnew System::Windows::Forms::Label());
			this->lb_PWR_ERR = (gcnew System::Windows::Forms::Label());
			this->gpb_ON_OFF = (gcnew System::Windows::Forms::GroupBox());
			this->cbb_SYNC_EN = (gcnew System::Windows::Forms::ComboBox());
			this->statusStrip->SuspendLayout();
			this->pn_Port->SuspendLayout();
			this->gpb_L1->SuspendLayout();
			this->pn_L1_Output->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->tkb_L1_Output))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nud_L1_Output))->BeginInit();
			this->pn_L1_Set->SuspendLayout();
			this->gpb_L2->SuspendLayout();
			this->pn_L2_Output->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->tkb_L2_Output))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nud_L2_Output))->BeginInit();
			this->pn_L2_Set->SuspendLayout();
			this->gpb_L3->SuspendLayout();
			this->pn_L3_Output->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->tkb_L3_Output))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nud_L3_Output))->BeginInit();
			this->pn_L3_Set->SuspendLayout();
			this->gpb_L4->SuspendLayout();
			this->pn_L4_Output->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->tkb_L4_Output))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nud_L4_Output))->BeginInit();
			this->pn_L4_Set->SuspendLayout();
			this->gpb_ON_OFF->SuspendLayout();
			this->SuspendLayout();
			// 
			// statusStrip
			// 
			this->statusStrip->BackColor = System::Drawing::Color::DarkGray;
			this->statusStrip->Font = (gcnew System::Drawing::Font(L"Arial", 14, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->statusStrip->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {
				this->tss_Status, this->tss_BaudRate,
					this->tss_REV
			});
			this->statusStrip->Location = System::Drawing::Point(0, 487);
			this->statusStrip->Name = L"statusStrip";
			this->statusStrip->Padding = System::Windows::Forms::Padding(1, 0, 21, 0);
			this->statusStrip->Size = System::Drawing::Size(892, 25);
			this->statusStrip->TabIndex = 0;
			// 
			// tss_Status
			// 
			this->tss_Status->BorderSides = static_cast<System::Windows::Forms::ToolStripStatusLabelBorderSides>((((System::Windows::Forms::ToolStripStatusLabelBorderSides::Left | System::Windows::Forms::ToolStripStatusLabelBorderSides::Top)
				| System::Windows::Forms::ToolStripStatusLabelBorderSides::Right)
				| System::Windows::Forms::ToolStripStatusLabelBorderSides::Bottom));
			this->tss_Status->Name = L"tss_Status";
			this->tss_Status->Padding = System::Windows::Forms::Padding(8, 0, 8, 0);
			this->tss_Status->Size = System::Drawing::Size(699, 20);
			this->tss_Status->Spring = true;
			this->tss_Status->Text = L"Disconnect";
			this->tss_Status->TextAlign = System::Drawing::ContentAlignment::MiddleLeft;
			// 
			// tss_BaudRate
			// 
			this->tss_BaudRate->BorderSides = static_cast<System::Windows::Forms::ToolStripStatusLabelBorderSides>((((System::Windows::Forms::ToolStripStatusLabelBorderSides::Left | System::Windows::Forms::ToolStripStatusLabelBorderSides::Top)
				| System::Windows::Forms::ToolStripStatusLabelBorderSides::Right)
				| System::Windows::Forms::ToolStripStatusLabelBorderSides::Bottom));
			this->tss_BaudRate->Name = L"tss_BaudRate";
			this->tss_BaudRate->Padding = System::Windows::Forms::Padding(8, 0, 8, 0);
			this->tss_BaudRate->Size = System::Drawing::Size(114, 20);
			this->tss_BaudRate->Text = L"115200 8-N-1";
			// 
			// tss_REV
			// 
			this->tss_REV->BorderSides = static_cast<System::Windows::Forms::ToolStripStatusLabelBorderSides>((((System::Windows::Forms::ToolStripStatusLabelBorderSides::Left | System::Windows::Forms::ToolStripStatusLabelBorderSides::Top)
				| System::Windows::Forms::ToolStripStatusLabelBorderSides::Right)
				| System::Windows::Forms::ToolStripStatusLabelBorderSides::Bottom));
			this->tss_REV->Name = L"tss_REV";
			this->tss_REV->Padding = System::Windows::Forms::Padding(8, 0, 8, 0);
			this->tss_REV->Size = System::Drawing::Size(57, 20);
			this->tss_REV->Text = L"V1.0";
			// 
			// timer
			// 
			this->timer->Enabled = true;
			this->timer->Interval = 50;
			this->timer->Tick += gcnew System::EventHandler(this, &MyForm::timer_Tick);
			// 
			// serialPort
			// 
			this->serialPort->BaudRate = 115200;
			this->serialPort->ReadBufferSize = 128;
			this->serialPort->WriteBufferSize = 64;
			this->serialPort->DataReceived += gcnew System::IO::Ports::SerialDataReceivedEventHandler(this, &MyForm::serialPort_DataReceived);
			// 
			// pn_Port
			// 
			this->pn_Port->BackColor = System::Drawing::Color::DarkGray;
			this->pn_Port->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_Port->Controls->Add(this->btn_Connect);
			this->pn_Port->Controls->Add(this->cbb_PortNo);
			this->pn_Port->Controls->Add(this->lb_PortNo);
			this->pn_Port->Location = System::Drawing::Point(762, 324);
			this->pn_Port->Name = L"pn_Port";
			this->pn_Port->Size = System::Drawing::Size(120, 106);
			this->pn_Port->TabIndex = 1;
			// 
			// btn_Connect
			// 
			this->btn_Connect->BackColor = System::Drawing::Color::LightGray;
			this->btn_Connect->Location = System::Drawing::Point(9, 64);
			this->btn_Connect->Name = L"btn_Connect";
			this->btn_Connect->Size = System::Drawing::Size(98, 28);
			this->btn_Connect->TabIndex = 2;
			this->btn_Connect->TabStop = false;
			this->btn_Connect->Text = L"Connect";
			this->btn_Connect->UseVisualStyleBackColor = false;
			this->btn_Connect->Click += gcnew System::EventHandler(this, &MyForm::btn_Connect_Click);
			// 
			// cbb_PortNo
			// 
			this->cbb_PortNo->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbb_PortNo->DropDownWidth = 84;
			this->cbb_PortNo->FlatStyle = System::Windows::Forms::FlatStyle::Popup;
			this->cbb_PortNo->FormattingEnabled = true;
			this->cbb_PortNo->Location = System::Drawing::Point(11, 28);
			this->cbb_PortNo->Name = L"cbb_PortNo";
			this->cbb_PortNo->Size = System::Drawing::Size(94, 26);
			this->cbb_PortNo->TabIndex = 1;
			this->cbb_PortNo->TabStop = false;
			this->cbb_PortNo->Click += gcnew System::EventHandler(this, &MyForm::cbb_PortNo_Click);
			// 
			// lb_PortNo
			// 
			this->lb_PortNo->AutoSize = true;
			this->lb_PortNo->Location = System::Drawing::Point(8, 8);
			this->lb_PortNo->Name = L"lb_PortNo";
			this->lb_PortNo->Size = System::Drawing::Size(65, 18);
			this->lb_PortNo->TabIndex = 0;
			this->lb_PortNo->Text = L"Port No.";
			// 
			// richTextBox
			// 
			this->richTextBox->BackColor = System::Drawing::Color::White;
			this->richTextBox->Font = (gcnew System::Drawing::Font(L"Courier New", 14, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->richTextBox->Location = System::Drawing::Point(229, 324);
			this->richTextBox->MaxLength = 32767;
			this->richTextBox->Name = L"richTextBox";
			this->richTextBox->ReadOnly = true;
			this->richTextBox->ScrollBars = System::Windows::Forms::RichTextBoxScrollBars::ForcedVertical;
			this->richTextBox->Size = System::Drawing::Size(521, 150);
			this->richTextBox->TabIndex = 2;
			this->richTextBox->TabStop = false;
			this->richTextBox->Text = L"";
			// 
			// lb_L1
			// 
			this->lb_L1->AutoSize = true;
			this->lb_L1->BackColor = System::Drawing::Color::Black;
			this->lb_L1->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->lb_L1->Font = (gcnew System::Drawing::Font(L"Arial", 16, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L1->ForeColor = System::Drawing::Color::White;
			this->lb_L1->Location = System::Drawing::Point(24, 12);
			this->lb_L1->MaximumSize = System::Drawing::Size(194, 25);
			this->lb_L1->MinimumSize = System::Drawing::Size(194, 25);
			this->lb_L1->Name = L"lb_L1";
			this->lb_L1->Size = System::Drawing::Size(194, 25);
			this->lb_L1->TabIndex = 3;
			this->lb_L1->Text = L"L1";
			this->lb_L1->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->lb_L1->UseMnemonic = false;
			// 
			// gpb_L1
			// 
			this->gpb_L1->Controls->Add(this->pn_L1_Output);
			this->gpb_L1->Controls->Add(this->pn_L1_Set);
			this->gpb_L1->Enabled = false;
			this->gpb_L1->Location = System::Drawing::Point(12, 26);
			this->gpb_L1->Name = L"gpb_L1";
			this->gpb_L1->Size = System::Drawing::Size(219, 286);
			this->gpb_L1->TabIndex = 4;
			this->gpb_L1->TabStop = false;
			// 
			// pn_L1_Output
			// 
			this->pn_L1_Output->BackColor = System::Drawing::Color::DarkGray;
			this->pn_L1_Output->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L1_Output->Controls->Add(this->lb_L1_MIN);
			this->pn_L1_Output->Controls->Add(this->lb_L1_MAX);
			this->pn_L1_Output->Controls->Add(this->tkb_L1_Output);
			this->pn_L1_Output->Controls->Add(this->lb_L1_PC);
			this->pn_L1_Output->Controls->Add(this->lb_L1_PCV);
			this->pn_L1_Output->Controls->Add(this->nud_L1_Output);
			this->pn_L1_Output->Controls->Add(this->lb_L1_Output);
			this->pn_L1_Output->Location = System::Drawing::Point(12, 134);
			this->pn_L1_Output->Name = L"pn_L1_Output";
			this->pn_L1_Output->Size = System::Drawing::Size(194, 140);
			this->pn_L1_Output->TabIndex = 1;
			// 
			// lb_L1_MIN
			// 
			this->lb_L1_MIN->AutoSize = true;
			this->lb_L1_MIN->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L1_MIN->Location = System::Drawing::Point(152, 112);
			this->lb_L1_MIN->Name = L"lb_L1_MIN";
			this->lb_L1_MIN->Size = System::Drawing::Size(28, 15);
			this->lb_L1_MIN->TabIndex = 6;
			this->lb_L1_MIN->Text = L"MIN";
			// 
			// lb_L1_MAX
			// 
			this->lb_L1_MAX->AutoSize = true;
			this->lb_L1_MAX->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L1_MAX->Location = System::Drawing::Point(152, 8);
			this->lb_L1_MAX->Name = L"lb_L1_MAX";
			this->lb_L1_MAX->Size = System::Drawing::Size(30, 15);
			this->lb_L1_MAX->TabIndex = 5;
			this->lb_L1_MAX->Text = L"MAX";
			// 
			// tkb_L1_Output
			// 
			this->tkb_L1_Output->LargeChange = 10;
			this->tkb_L1_Output->Location = System::Drawing::Point(124, 2);
			this->tkb_L1_Output->Maximum = 500;
			this->tkb_L1_Output->Name = L"tkb_L1_Output";
			this->tkb_L1_Output->Orientation = System::Windows::Forms::Orientation::Vertical;
			this->tkb_L1_Output->Size = System::Drawing::Size(45, 130);
			this->tkb_L1_Output->TabIndex = 4;
			this->tkb_L1_Output->TabStop = false;
			this->tkb_L1_Output->TickFrequency = 50;
			this->tkb_L1_Output->ValueChanged += gcnew System::EventHandler(this, &MyForm::tkb_L1_Output_ValueChanged);
			// 
			// lb_L1_PC
			// 
			this->lb_L1_PC->AutoSize = true;
			this->lb_L1_PC->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L1_PC->Location = System::Drawing::Point(92, 112);
			this->lb_L1_PC->Name = L"lb_L1_PC";
			this->lb_L1_PC->Size = System::Drawing::Size(18, 15);
			this->lb_L1_PC->TabIndex = 3;
			this->lb_L1_PC->Text = L"%";
			// 
			// lb_L1_PCV
			// 
			this->lb_L1_PCV->AutoSize = true;
			this->lb_L1_PCV->BackColor = System::Drawing::Color::Black;
			this->lb_L1_PCV->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->lb_L1_PCV->Font = (gcnew System::Drawing::Font(L"Arial", 20, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L1_PCV->ForeColor = System::Drawing::Color::Lime;
			this->lb_L1_PCV->Location = System::Drawing::Point(25, 92);
			this->lb_L1_PCV->MaximumSize = System::Drawing::Size(64, 32);
			this->lb_L1_PCV->MinimumSize = System::Drawing::Size(64, 32);
			this->lb_L1_PCV->Name = L"lb_L1_PCV";
			this->lb_L1_PCV->Size = System::Drawing::Size(64, 32);
			this->lb_L1_PCV->TabIndex = 2;
			this->lb_L1_PCV->Text = L"0.0";
			this->lb_L1_PCV->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			this->lb_L1_PCV->UseCompatibleTextRendering = true;
			this->lb_L1_PCV->UseMnemonic = false;
			// 
			// nud_L1_Output
			// 
			this->nud_L1_Output->BackColor = System::Drawing::Color::Black;
			this->nud_L1_Output->Font = (gcnew System::Drawing::Font(L"Arial", 40, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->nud_L1_Output->ForeColor = System::Drawing::Color::Cyan;
			this->nud_L1_Output->Location = System::Drawing::Point(10, 28);
			this->nud_L1_Output->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 500, 0, 0, 0 });
			this->nud_L1_Output->Name = L"nud_L1_Output";
			this->nud_L1_Output->Size = System::Drawing::Size(96, 53);
			this->nud_L1_Output->TabIndex = 1;
			this->nud_L1_Output->TabStop = false;
			this->nud_L1_Output->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->nud_L1_Output->ValueChanged += gcnew System::EventHandler(this, &MyForm::nud_L1_Output_ValueChanged);
			// 
			// lb_L1_Output
			// 
			this->lb_L1_Output->AutoSize = true;
			this->lb_L1_Output->ForeColor = System::Drawing::Color::Blue;
			this->lb_L1_Output->Location = System::Drawing::Point(8, 8);
			this->lb_L1_Output->Name = L"lb_L1_Output";
			this->lb_L1_Output->Size = System::Drawing::Size(91, 18);
			this->lb_L1_Output->TabIndex = 0;
			this->lb_L1_Output->Text = L"Output (mA)";
			// 
			// pn_L1_Set
			// 
			this->pn_L1_Set->BackColor = System::Drawing::Color::DarkGray;
			this->pn_L1_Set->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L1_Set->Controls->Add(this->btn_L1);
			this->pn_L1_Set->Controls->Add(this->pn_L1_LED);
			this->pn_L1_Set->Controls->Add(this->ckb_L1_EXT);
			this->pn_L1_Set->Controls->Add(this->cbb_L1_MaxC);
			this->pn_L1_Set->Controls->Add(this->lb_L1_MaxC);
			this->pn_L1_Set->Location = System::Drawing::Point(12, 22);
			this->pn_L1_Set->Name = L"pn_L1_Set";
			this->pn_L1_Set->Size = System::Drawing::Size(194, 102);
			this->pn_L1_Set->TabIndex = 0;
			// 
			// btn_L1
			// 
			this->btn_L1->BackColor = System::Drawing::Color::LightGray;
			this->btn_L1->Location = System::Drawing::Point(124, 27);
			this->btn_L1->Name = L"btn_L1";
			this->btn_L1->Size = System::Drawing::Size(56, 28);
			this->btn_L1->TabIndex = 4;
			this->btn_L1->TabStop = false;
			this->btn_L1->Text = L"ON";
			this->btn_L1->UseVisualStyleBackColor = false;
			this->btn_L1->Click += gcnew System::EventHandler(this, &MyForm::btn_L1_Click);
			// 
			// pn_L1_LED
			// 
			this->pn_L1_LED->BackColor = System::Drawing::Color::Black;
			this->pn_L1_LED->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L1_LED->ForeColor = System::Drawing::Color::White;
			this->pn_L1_LED->Location = System::Drawing::Point(124, 12);
			this->pn_L1_LED->Name = L"pn_L1_LED";
			this->pn_L1_LED->Size = System::Drawing::Size(54, 12);
			this->pn_L1_LED->TabIndex = 3;
			// 
			// ckb_L1_EXT
			// 
			this->ckb_L1_EXT->AutoSize = true;
			this->ckb_L1_EXT->ForeColor = System::Drawing::Color::Maroon;
			this->ckb_L1_EXT->Location = System::Drawing::Point(10, 68);
			this->ckb_L1_EXT->Name = L"ckb_L1_EXT";
			this->ckb_L1_EXT->Size = System::Drawing::Size(177, 22);
			this->ckb_L1_EXT->TabIndex = 2;
			this->ckb_L1_EXT->TabStop = false;
			this->ckb_L1_EXT->Text = L"EXT. ON/OFF Control";
			this->ckb_L1_EXT->UseVisualStyleBackColor = true;
			this->ckb_L1_EXT->CheckedChanged += gcnew System::EventHandler(this, &MyForm::ckb_L1_EXT_CheckedChanged);
			// 
			// cbb_L1_MaxC
			// 
			this->cbb_L1_MaxC->BackColor = System::Drawing::Color::Black;
			this->cbb_L1_MaxC->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbb_L1_MaxC->DropDownWidth = 96;
			this->cbb_L1_MaxC->FlatStyle = System::Windows::Forms::FlatStyle::Popup;
			this->cbb_L1_MaxC->Font = (gcnew System::Drawing::Font(L"Arial", 20, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->cbb_L1_MaxC->ForeColor = System::Drawing::Color::Yellow;
			this->cbb_L1_MaxC->FormattingEnabled = true;
			this->cbb_L1_MaxC->Items->AddRange(gcnew cli::array< System::Object^  >(4) { L" 500mA", L" 600mA", L" 700mA", L" 800mA" });
			this->cbb_L1_MaxC->Location = System::Drawing::Point(10, 28);
			this->cbb_L1_MaxC->MaxDropDownItems = 4;
			this->cbb_L1_MaxC->Name = L"cbb_L1_MaxC";
			this->cbb_L1_MaxC->Size = System::Drawing::Size(96, 32);
			this->cbb_L1_MaxC->TabIndex = 1;
			this->cbb_L1_MaxC->TabStop = false;
			this->cbb_L1_MaxC->SelectedIndexChanged += gcnew System::EventHandler(this, &MyForm::cbb_L1_MaxC_SelectedIndexChanged);
			// 
			// lb_L1_MaxC
			// 
			this->lb_L1_MaxC->AutoSize = true;
			this->lb_L1_MaxC->ForeColor = System::Drawing::Color::Maroon;
			this->lb_L1_MaxC->Location = System::Drawing::Point(8, 8);
			this->lb_L1_MaxC->Name = L"lb_L1_MaxC";
			this->lb_L1_MaxC->Size = System::Drawing::Size(96, 18);
			this->lb_L1_MaxC->TabIndex = 0;
			this->lb_L1_MaxC->Text = L"Max. Current";
			// 
			// lb_L2
			// 
			this->lb_L2->AutoSize = true;
			this->lb_L2->BackColor = System::Drawing::Color::Black;
			this->lb_L2->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->lb_L2->Font = (gcnew System::Drawing::Font(L"Arial", 16, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L2->ForeColor = System::Drawing::Color::White;
			this->lb_L2->Location = System::Drawing::Point(241, 12);
			this->lb_L2->MaximumSize = System::Drawing::Size(194, 25);
			this->lb_L2->MinimumSize = System::Drawing::Size(194, 25);
			this->lb_L2->Name = L"lb_L2";
			this->lb_L2->Size = System::Drawing::Size(194, 25);
			this->lb_L2->TabIndex = 5;
			this->lb_L2->Text = L"L2";
			this->lb_L2->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->lb_L2->UseMnemonic = false;
			// 
			// gpb_L2
			// 
			this->gpb_L2->Controls->Add(this->pn_L2_Output);
			this->gpb_L2->Controls->Add(this->pn_L2_Set);
			this->gpb_L2->Enabled = false;
			this->gpb_L2->Location = System::Drawing::Point(229, 26);
			this->gpb_L2->Name = L"gpb_L2";
			this->gpb_L2->Size = System::Drawing::Size(219, 286);
			this->gpb_L2->TabIndex = 6;
			this->gpb_L2->TabStop = false;
			// 
			// pn_L2_Output
			// 
			this->pn_L2_Output->BackColor = System::Drawing::Color::DarkGray;
			this->pn_L2_Output->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L2_Output->Controls->Add(this->lb_L2_MIN);
			this->pn_L2_Output->Controls->Add(this->lb_L2_MAX);
			this->pn_L2_Output->Controls->Add(this->tkb_L2_Output);
			this->pn_L2_Output->Controls->Add(this->lb_L2_PC);
			this->pn_L2_Output->Controls->Add(this->lb_L2_PCV);
			this->pn_L2_Output->Controls->Add(this->nud_L2_Output);
			this->pn_L2_Output->Controls->Add(this->lb_L2_Output);
			this->pn_L2_Output->Location = System::Drawing::Point(12, 134);
			this->pn_L2_Output->Name = L"pn_L2_Output";
			this->pn_L2_Output->Size = System::Drawing::Size(194, 140);
			this->pn_L2_Output->TabIndex = 1;
			// 
			// lb_L2_MIN
			// 
			this->lb_L2_MIN->AutoSize = true;
			this->lb_L2_MIN->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L2_MIN->Location = System::Drawing::Point(152, 112);
			this->lb_L2_MIN->Name = L"lb_L2_MIN";
			this->lb_L2_MIN->Size = System::Drawing::Size(28, 15);
			this->lb_L2_MIN->TabIndex = 6;
			this->lb_L2_MIN->Text = L"MIN";
			// 
			// lb_L2_MAX
			// 
			this->lb_L2_MAX->AutoSize = true;
			this->lb_L2_MAX->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L2_MAX->Location = System::Drawing::Point(152, 8);
			this->lb_L2_MAX->Name = L"lb_L2_MAX";
			this->lb_L2_MAX->Size = System::Drawing::Size(30, 15);
			this->lb_L2_MAX->TabIndex = 5;
			this->lb_L2_MAX->Text = L"MAX";
			// 
			// tkb_L2_Output
			// 
			this->tkb_L2_Output->LargeChange = 10;
			this->tkb_L2_Output->Location = System::Drawing::Point(124, 2);
			this->tkb_L2_Output->Maximum = 500;
			this->tkb_L2_Output->Name = L"tkb_L2_Output";
			this->tkb_L2_Output->Orientation = System::Windows::Forms::Orientation::Vertical;
			this->tkb_L2_Output->Size = System::Drawing::Size(45, 130);
			this->tkb_L2_Output->TabIndex = 4;
			this->tkb_L2_Output->TabStop = false;
			this->tkb_L2_Output->TickFrequency = 50;
			this->tkb_L2_Output->ValueChanged += gcnew System::EventHandler(this, &MyForm::tkb_L2_Output_ValueChanged);
			// 
			// lb_L2_PC
			// 
			this->lb_L2_PC->AutoSize = true;
			this->lb_L2_PC->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L2_PC->Location = System::Drawing::Point(92, 112);
			this->lb_L2_PC->Name = L"lb_L2_PC";
			this->lb_L2_PC->Size = System::Drawing::Size(18, 15);
			this->lb_L2_PC->TabIndex = 3;
			this->lb_L2_PC->Text = L"%";
			// 
			// lb_L2_PCV
			// 
			this->lb_L2_PCV->AutoSize = true;
			this->lb_L2_PCV->BackColor = System::Drawing::Color::Black;
			this->lb_L2_PCV->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->lb_L2_PCV->Font = (gcnew System::Drawing::Font(L"Arial", 20, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L2_PCV->ForeColor = System::Drawing::Color::Lime;
			this->lb_L2_PCV->Location = System::Drawing::Point(25, 92);
			this->lb_L2_PCV->MaximumSize = System::Drawing::Size(64, 32);
			this->lb_L2_PCV->MinimumSize = System::Drawing::Size(64, 32);
			this->lb_L2_PCV->Name = L"lb_L2_PCV";
			this->lb_L2_PCV->Size = System::Drawing::Size(64, 32);
			this->lb_L2_PCV->TabIndex = 2;
			this->lb_L2_PCV->Text = L"0.0";
			this->lb_L2_PCV->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			this->lb_L2_PCV->UseCompatibleTextRendering = true;
			this->lb_L2_PCV->UseMnemonic = false;
			// 
			// nud_L2_Output
			// 
			this->nud_L2_Output->BackColor = System::Drawing::Color::Black;
			this->nud_L2_Output->Font = (gcnew System::Drawing::Font(L"Arial", 40, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->nud_L2_Output->ForeColor = System::Drawing::Color::Cyan;
			this->nud_L2_Output->Location = System::Drawing::Point(10, 28);
			this->nud_L2_Output->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 500, 0, 0, 0 });
			this->nud_L2_Output->Name = L"nud_L2_Output";
			this->nud_L2_Output->Size = System::Drawing::Size(96, 53);
			this->nud_L2_Output->TabIndex = 1;
			this->nud_L2_Output->TabStop = false;
			this->nud_L2_Output->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->nud_L2_Output->ValueChanged += gcnew System::EventHandler(this, &MyForm::nud_L2_Output_ValueChanged);
			// 
			// lb_L2_Output
			// 
			this->lb_L2_Output->AutoSize = true;
			this->lb_L2_Output->ForeColor = System::Drawing::Color::Blue;
			this->lb_L2_Output->Location = System::Drawing::Point(8, 8);
			this->lb_L2_Output->Name = L"lb_L2_Output";
			this->lb_L2_Output->Size = System::Drawing::Size(91, 18);
			this->lb_L2_Output->TabIndex = 0;
			this->lb_L2_Output->Text = L"Output (mA)";
			// 
			// pn_L2_Set
			// 
			this->pn_L2_Set->BackColor = System::Drawing::Color::DarkGray;
			this->pn_L2_Set->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L2_Set->Controls->Add(this->btn_L2);
			this->pn_L2_Set->Controls->Add(this->pn_L2_LED);
			this->pn_L2_Set->Controls->Add(this->ckb_L2_EXT);
			this->pn_L2_Set->Controls->Add(this->cbb_L2_MaxC);
			this->pn_L2_Set->Controls->Add(this->lb_L2_MaxC);
			this->pn_L2_Set->Location = System::Drawing::Point(12, 22);
			this->pn_L2_Set->Name = L"pn_L2_Set";
			this->pn_L2_Set->Size = System::Drawing::Size(194, 102);
			this->pn_L2_Set->TabIndex = 0;
			// 
			// btn_L2
			// 
			this->btn_L2->BackColor = System::Drawing::Color::LightGray;
			this->btn_L2->Location = System::Drawing::Point(124, 27);
			this->btn_L2->Name = L"btn_L2";
			this->btn_L2->Size = System::Drawing::Size(56, 28);
			this->btn_L2->TabIndex = 4;
			this->btn_L2->TabStop = false;
			this->btn_L2->Text = L"ON";
			this->btn_L2->UseVisualStyleBackColor = false;
			this->btn_L2->Click += gcnew System::EventHandler(this, &MyForm::btn_L2_Click);
			// 
			// pn_L2_LED
			// 
			this->pn_L2_LED->BackColor = System::Drawing::Color::Black;
			this->pn_L2_LED->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L2_LED->ForeColor = System::Drawing::Color::White;
			this->pn_L2_LED->Location = System::Drawing::Point(124, 12);
			this->pn_L2_LED->Name = L"pn_L2_LED";
			this->pn_L2_LED->Size = System::Drawing::Size(54, 12);
			this->pn_L2_LED->TabIndex = 3;
			// 
			// ckb_L2_EXT
			// 
			this->ckb_L2_EXT->AutoSize = true;
			this->ckb_L2_EXT->ForeColor = System::Drawing::Color::Maroon;
			this->ckb_L2_EXT->Location = System::Drawing::Point(10, 68);
			this->ckb_L2_EXT->Name = L"ckb_L2_EXT";
			this->ckb_L2_EXT->Size = System::Drawing::Size(177, 22);
			this->ckb_L2_EXT->TabIndex = 2;
			this->ckb_L2_EXT->TabStop = false;
			this->ckb_L2_EXT->Text = L"EXT. ON/OFF Control";
			this->ckb_L2_EXT->UseVisualStyleBackColor = true;
			this->ckb_L2_EXT->CheckedChanged += gcnew System::EventHandler(this, &MyForm::ckb_L2_EXT_CheckedChanged);
			// 
			// cbb_L2_MaxC
			// 
			this->cbb_L2_MaxC->BackColor = System::Drawing::Color::Black;
			this->cbb_L2_MaxC->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbb_L2_MaxC->DropDownWidth = 96;
			this->cbb_L2_MaxC->FlatStyle = System::Windows::Forms::FlatStyle::Popup;
			this->cbb_L2_MaxC->Font = (gcnew System::Drawing::Font(L"Arial", 20, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->cbb_L2_MaxC->ForeColor = System::Drawing::Color::Yellow;
			this->cbb_L2_MaxC->FormattingEnabled = true;
			this->cbb_L2_MaxC->Items->AddRange(gcnew cli::array< System::Object^  >(4) { L" 500mA", L" 600mA", L" 700mA", L" 800mA" });
			this->cbb_L2_MaxC->Location = System::Drawing::Point(10, 28);
			this->cbb_L2_MaxC->MaxDropDownItems = 4;
			this->cbb_L2_MaxC->Name = L"cbb_L2_MaxC";
			this->cbb_L2_MaxC->Size = System::Drawing::Size(96, 32);
			this->cbb_L2_MaxC->TabIndex = 1;
			this->cbb_L2_MaxC->TabStop = false;
			this->cbb_L2_MaxC->SelectedIndexChanged += gcnew System::EventHandler(this, &MyForm::cbb_L2_MaxC_SelectedIndexChanged);
			// 
			// lb_L2_MaxC
			// 
			this->lb_L2_MaxC->AutoSize = true;
			this->lb_L2_MaxC->ForeColor = System::Drawing::Color::Maroon;
			this->lb_L2_MaxC->Location = System::Drawing::Point(8, 8);
			this->lb_L2_MaxC->Name = L"lb_L2_MaxC";
			this->lb_L2_MaxC->Size = System::Drawing::Size(96, 18);
			this->lb_L2_MaxC->TabIndex = 0;
			this->lb_L2_MaxC->Text = L"Max. Current";
			// 
			// lb_L3
			// 
			this->lb_L3->AutoSize = true;
			this->lb_L3->BackColor = System::Drawing::Color::Black;
			this->lb_L3->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->lb_L3->Font = (gcnew System::Drawing::Font(L"Arial", 16, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L3->ForeColor = System::Drawing::Color::White;
			this->lb_L3->Location = System::Drawing::Point(458, 12);
			this->lb_L3->MaximumSize = System::Drawing::Size(194, 25);
			this->lb_L3->MinimumSize = System::Drawing::Size(194, 25);
			this->lb_L3->Name = L"lb_L3";
			this->lb_L3->Size = System::Drawing::Size(194, 25);
			this->lb_L3->TabIndex = 7;
			this->lb_L3->Text = L"L3";
			this->lb_L3->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->lb_L3->UseMnemonic = false;
			// 
			// gpb_L3
			// 
			this->gpb_L3->Controls->Add(this->pn_L3_Output);
			this->gpb_L3->Controls->Add(this->pn_L3_Set);
			this->gpb_L3->Enabled = false;
			this->gpb_L3->Location = System::Drawing::Point(446, 26);
			this->gpb_L3->Name = L"gpb_L3";
			this->gpb_L3->Size = System::Drawing::Size(219, 286);
			this->gpb_L3->TabIndex = 8;
			this->gpb_L3->TabStop = false;
			// 
			// pn_L3_Output
			// 
			this->pn_L3_Output->BackColor = System::Drawing::Color::DarkGray;
			this->pn_L3_Output->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L3_Output->Controls->Add(this->lb_L3_MIN);
			this->pn_L3_Output->Controls->Add(this->lb_L3_MAX);
			this->pn_L3_Output->Controls->Add(this->tkb_L3_Output);
			this->pn_L3_Output->Controls->Add(this->lb_L3_PC);
			this->pn_L3_Output->Controls->Add(this->lb_L3_PCV);
			this->pn_L3_Output->Controls->Add(this->nud_L3_Output);
			this->pn_L3_Output->Controls->Add(this->lb_L3_Output);
			this->pn_L3_Output->Location = System::Drawing::Point(12, 134);
			this->pn_L3_Output->Name = L"pn_L3_Output";
			this->pn_L3_Output->Size = System::Drawing::Size(194, 140);
			this->pn_L3_Output->TabIndex = 1;
			// 
			// lb_L3_MIN
			// 
			this->lb_L3_MIN->AutoSize = true;
			this->lb_L3_MIN->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L3_MIN->Location = System::Drawing::Point(152, 112);
			this->lb_L3_MIN->Name = L"lb_L3_MIN";
			this->lb_L3_MIN->Size = System::Drawing::Size(28, 15);
			this->lb_L3_MIN->TabIndex = 6;
			this->lb_L3_MIN->Text = L"MIN";
			// 
			// lb_L3_MAX
			// 
			this->lb_L3_MAX->AutoSize = true;
			this->lb_L3_MAX->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L3_MAX->Location = System::Drawing::Point(152, 8);
			this->lb_L3_MAX->Name = L"lb_L3_MAX";
			this->lb_L3_MAX->Size = System::Drawing::Size(30, 15);
			this->lb_L3_MAX->TabIndex = 5;
			this->lb_L3_MAX->Text = L"MAX";
			// 
			// tkb_L3_Output
			// 
			this->tkb_L3_Output->LargeChange = 10;
			this->tkb_L3_Output->Location = System::Drawing::Point(124, 2);
			this->tkb_L3_Output->Maximum = 500;
			this->tkb_L3_Output->Name = L"tkb_L3_Output";
			this->tkb_L3_Output->Orientation = System::Windows::Forms::Orientation::Vertical;
			this->tkb_L3_Output->Size = System::Drawing::Size(45, 130);
			this->tkb_L3_Output->TabIndex = 4;
			this->tkb_L3_Output->TabStop = false;
			this->tkb_L3_Output->TickFrequency = 50;
			this->tkb_L3_Output->ValueChanged += gcnew System::EventHandler(this, &MyForm::tkb_L3_Output_ValueChanged);
			// 
			// lb_L3_PC
			// 
			this->lb_L3_PC->AutoSize = true;
			this->lb_L3_PC->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L3_PC->Location = System::Drawing::Point(92, 112);
			this->lb_L3_PC->Name = L"lb_L3_PC";
			this->lb_L3_PC->Size = System::Drawing::Size(18, 15);
			this->lb_L3_PC->TabIndex = 3;
			this->lb_L3_PC->Text = L"%";
			// 
			// lb_L3_PCV
			// 
			this->lb_L3_PCV->AutoSize = true;
			this->lb_L3_PCV->BackColor = System::Drawing::Color::Black;
			this->lb_L3_PCV->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->lb_L3_PCV->Font = (gcnew System::Drawing::Font(L"Arial", 20, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L3_PCV->ForeColor = System::Drawing::Color::Lime;
			this->lb_L3_PCV->Location = System::Drawing::Point(25, 92);
			this->lb_L3_PCV->MaximumSize = System::Drawing::Size(64, 32);
			this->lb_L3_PCV->MinimumSize = System::Drawing::Size(64, 32);
			this->lb_L3_PCV->Name = L"lb_L3_PCV";
			this->lb_L3_PCV->Size = System::Drawing::Size(64, 32);
			this->lb_L3_PCV->TabIndex = 2;
			this->lb_L3_PCV->Text = L"0.0";
			this->lb_L3_PCV->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			this->lb_L3_PCV->UseCompatibleTextRendering = true;
			this->lb_L3_PCV->UseMnemonic = false;
			// 
			// nud_L3_Output
			// 
			this->nud_L3_Output->BackColor = System::Drawing::Color::Black;
			this->nud_L3_Output->Font = (gcnew System::Drawing::Font(L"Arial", 40, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->nud_L3_Output->ForeColor = System::Drawing::Color::Cyan;
			this->nud_L3_Output->Location = System::Drawing::Point(10, 28);
			this->nud_L3_Output->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 500, 0, 0, 0 });
			this->nud_L3_Output->Name = L"nud_L3_Output";
			this->nud_L3_Output->Size = System::Drawing::Size(96, 53);
			this->nud_L3_Output->TabIndex = 1;
			this->nud_L3_Output->TabStop = false;
			this->nud_L3_Output->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->nud_L3_Output->ValueChanged += gcnew System::EventHandler(this, &MyForm::nud_L3_Output_ValueChanged);
			// 
			// lb_L3_Output
			// 
			this->lb_L3_Output->AutoSize = true;
			this->lb_L3_Output->ForeColor = System::Drawing::Color::Blue;
			this->lb_L3_Output->Location = System::Drawing::Point(8, 8);
			this->lb_L3_Output->Name = L"lb_L3_Output";
			this->lb_L3_Output->Size = System::Drawing::Size(91, 18);
			this->lb_L3_Output->TabIndex = 0;
			this->lb_L3_Output->Text = L"Output (mA)";
			// 
			// pn_L3_Set
			// 
			this->pn_L3_Set->BackColor = System::Drawing::Color::DarkGray;
			this->pn_L3_Set->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L3_Set->Controls->Add(this->btn_L3);
			this->pn_L3_Set->Controls->Add(this->pn_L3_LED);
			this->pn_L3_Set->Controls->Add(this->ckb_L3_EXT);
			this->pn_L3_Set->Controls->Add(this->cbb_L3_MaxC);
			this->pn_L3_Set->Controls->Add(this->lb_L3_MaxC);
			this->pn_L3_Set->Location = System::Drawing::Point(12, 22);
			this->pn_L3_Set->Name = L"pn_L3_Set";
			this->pn_L3_Set->Size = System::Drawing::Size(194, 102);
			this->pn_L3_Set->TabIndex = 0;
			// 
			// btn_L3
			// 
			this->btn_L3->BackColor = System::Drawing::Color::LightGray;
			this->btn_L3->Location = System::Drawing::Point(124, 27);
			this->btn_L3->Name = L"btn_L3";
			this->btn_L3->Size = System::Drawing::Size(56, 28);
			this->btn_L3->TabIndex = 4;
			this->btn_L3->TabStop = false;
			this->btn_L3->Text = L"ON";
			this->btn_L3->UseVisualStyleBackColor = false;
			this->btn_L3->Click += gcnew System::EventHandler(this, &MyForm::btn_L3_Click);
			// 
			// pn_L3_LED
			// 
			this->pn_L3_LED->BackColor = System::Drawing::Color::Black;
			this->pn_L3_LED->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L3_LED->ForeColor = System::Drawing::Color::White;
			this->pn_L3_LED->Location = System::Drawing::Point(124, 12);
			this->pn_L3_LED->Name = L"pn_L3_LED";
			this->pn_L3_LED->Size = System::Drawing::Size(54, 12);
			this->pn_L3_LED->TabIndex = 3;
			// 
			// ckb_L3_EXT
			// 
			this->ckb_L3_EXT->AutoSize = true;
			this->ckb_L3_EXT->ForeColor = System::Drawing::Color::Maroon;
			this->ckb_L3_EXT->Location = System::Drawing::Point(10, 68);
			this->ckb_L3_EXT->Name = L"ckb_L3_EXT";
			this->ckb_L3_EXT->Size = System::Drawing::Size(177, 22);
			this->ckb_L3_EXT->TabIndex = 2;
			this->ckb_L3_EXT->TabStop = false;
			this->ckb_L3_EXT->Text = L"EXT. ON/OFF Control";
			this->ckb_L3_EXT->UseVisualStyleBackColor = true;
			this->ckb_L3_EXT->CheckedChanged += gcnew System::EventHandler(this, &MyForm::ckb_L3_EXT_CheckedChanged);
			// 
			// cbb_L3_MaxC
			// 
			this->cbb_L3_MaxC->BackColor = System::Drawing::Color::Black;
			this->cbb_L3_MaxC->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbb_L3_MaxC->DropDownWidth = 96;
			this->cbb_L3_MaxC->FlatStyle = System::Windows::Forms::FlatStyle::Popup;
			this->cbb_L3_MaxC->Font = (gcnew System::Drawing::Font(L"Arial", 20, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->cbb_L3_MaxC->ForeColor = System::Drawing::Color::Yellow;
			this->cbb_L3_MaxC->FormattingEnabled = true;
			this->cbb_L3_MaxC->Items->AddRange(gcnew cli::array< System::Object^  >(4) { L" 500mA", L" 600mA", L" 700mA", L" 800mA" });
			this->cbb_L3_MaxC->Location = System::Drawing::Point(10, 28);
			this->cbb_L3_MaxC->MaxDropDownItems = 4;
			this->cbb_L3_MaxC->Name = L"cbb_L3_MaxC";
			this->cbb_L3_MaxC->Size = System::Drawing::Size(96, 32);
			this->cbb_L3_MaxC->TabIndex = 1;
			this->cbb_L3_MaxC->TabStop = false;
			this->cbb_L3_MaxC->SelectedIndexChanged += gcnew System::EventHandler(this, &MyForm::cbb_L3_MaxC_SelectedIndexChanged);
			// 
			// lb_L3_MaxC
			// 
			this->lb_L3_MaxC->AutoSize = true;
			this->lb_L3_MaxC->ForeColor = System::Drawing::Color::Maroon;
			this->lb_L3_MaxC->Location = System::Drawing::Point(8, 8);
			this->lb_L3_MaxC->Name = L"lb_L3_MaxC";
			this->lb_L3_MaxC->Size = System::Drawing::Size(96, 18);
			this->lb_L3_MaxC->TabIndex = 0;
			this->lb_L3_MaxC->Text = L"Max. Current";
			// 
			// lb_L4
			// 
			this->lb_L4->AutoSize = true;
			this->lb_L4->BackColor = System::Drawing::Color::Black;
			this->lb_L4->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->lb_L4->Font = (gcnew System::Drawing::Font(L"Arial", 16, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L4->ForeColor = System::Drawing::Color::White;
			this->lb_L4->Location = System::Drawing::Point(675, 12);
			this->lb_L4->MaximumSize = System::Drawing::Size(194, 25);
			this->lb_L4->MinimumSize = System::Drawing::Size(194, 25);
			this->lb_L4->Name = L"lb_L4";
			this->lb_L4->Size = System::Drawing::Size(194, 25);
			this->lb_L4->TabIndex = 9;
			this->lb_L4->Text = L"L4";
			this->lb_L4->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->lb_L4->UseMnemonic = false;
			// 
			// gpb_L4
			// 
			this->gpb_L4->Controls->Add(this->pn_L4_Output);
			this->gpb_L4->Controls->Add(this->pn_L4_Set);
			this->gpb_L4->Enabled = false;
			this->gpb_L4->Location = System::Drawing::Point(663, 26);
			this->gpb_L4->Name = L"gpb_L4";
			this->gpb_L4->Size = System::Drawing::Size(219, 286);
			this->gpb_L4->TabIndex = 10;
			this->gpb_L4->TabStop = false;
			// 
			// pn_L4_Output
			// 
			this->pn_L4_Output->BackColor = System::Drawing::Color::DarkGray;
			this->pn_L4_Output->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L4_Output->Controls->Add(this->lb_L4_MIN);
			this->pn_L4_Output->Controls->Add(this->lb_L4_MAX);
			this->pn_L4_Output->Controls->Add(this->tkb_L4_Output);
			this->pn_L4_Output->Controls->Add(this->lb_L4_PC);
			this->pn_L4_Output->Controls->Add(this->lb_L4_PCV);
			this->pn_L4_Output->Controls->Add(this->nud_L4_Output);
			this->pn_L4_Output->Controls->Add(this->lb_L4_Output);
			this->pn_L4_Output->Location = System::Drawing::Point(12, 134);
			this->pn_L4_Output->Name = L"pn_L4_Output";
			this->pn_L4_Output->Size = System::Drawing::Size(194, 140);
			this->pn_L4_Output->TabIndex = 1;
			// 
			// lb_L4_MIN
			// 
			this->lb_L4_MIN->AutoSize = true;
			this->lb_L4_MIN->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L4_MIN->Location = System::Drawing::Point(152, 112);
			this->lb_L4_MIN->Name = L"lb_L4_MIN";
			this->lb_L4_MIN->Size = System::Drawing::Size(28, 15);
			this->lb_L4_MIN->TabIndex = 6;
			this->lb_L4_MIN->Text = L"MIN";
			// 
			// lb_L4_MAX
			// 
			this->lb_L4_MAX->AutoSize = true;
			this->lb_L4_MAX->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L4_MAX->Location = System::Drawing::Point(152, 8);
			this->lb_L4_MAX->Name = L"lb_L4_MAX";
			this->lb_L4_MAX->Size = System::Drawing::Size(30, 15);
			this->lb_L4_MAX->TabIndex = 5;
			this->lb_L4_MAX->Text = L"MAX";
			// 
			// tkb_L4_Output
			// 
			this->tkb_L4_Output->LargeChange = 10;
			this->tkb_L4_Output->Location = System::Drawing::Point(124, 2);
			this->tkb_L4_Output->Maximum = 500;
			this->tkb_L4_Output->Name = L"tkb_L4_Output";
			this->tkb_L4_Output->Orientation = System::Windows::Forms::Orientation::Vertical;
			this->tkb_L4_Output->Size = System::Drawing::Size(45, 130);
			this->tkb_L4_Output->TabIndex = 4;
			this->tkb_L4_Output->TabStop = false;
			this->tkb_L4_Output->TickFrequency = 50;
			this->tkb_L4_Output->ValueChanged += gcnew System::EventHandler(this, &MyForm::tkb_L4_Output_ValueChanged);
			// 
			// lb_L4_PC
			// 
			this->lb_L4_PC->AutoSize = true;
			this->lb_L4_PC->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L4_PC->Location = System::Drawing::Point(92, 112);
			this->lb_L4_PC->Name = L"lb_L4_PC";
			this->lb_L4_PC->Size = System::Drawing::Size(18, 15);
			this->lb_L4_PC->TabIndex = 3;
			this->lb_L4_PC->Text = L"%";
			// 
			// lb_L4_PCV
			// 
			this->lb_L4_PCV->AutoSize = true;
			this->lb_L4_PCV->BackColor = System::Drawing::Color::Black;
			this->lb_L4_PCV->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->lb_L4_PCV->Font = (gcnew System::Drawing::Font(L"Arial", 20, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_L4_PCV->ForeColor = System::Drawing::Color::Lime;
			this->lb_L4_PCV->Location = System::Drawing::Point(25, 92);
			this->lb_L4_PCV->MaximumSize = System::Drawing::Size(64, 32);
			this->lb_L4_PCV->MinimumSize = System::Drawing::Size(64, 32);
			this->lb_L4_PCV->Name = L"lb_L4_PCV";
			this->lb_L4_PCV->Size = System::Drawing::Size(64, 32);
			this->lb_L4_PCV->TabIndex = 2;
			this->lb_L4_PCV->Text = L"0.0";
			this->lb_L4_PCV->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			this->lb_L4_PCV->UseCompatibleTextRendering = true;
			this->lb_L4_PCV->UseMnemonic = false;
			// 
			// nud_L4_Output
			// 
			this->nud_L4_Output->BackColor = System::Drawing::Color::Black;
			this->nud_L4_Output->Font = (gcnew System::Drawing::Font(L"Arial", 40, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->nud_L4_Output->ForeColor = System::Drawing::Color::Cyan;
			this->nud_L4_Output->Location = System::Drawing::Point(10, 28);
			this->nud_L4_Output->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 500, 0, 0, 0 });
			this->nud_L4_Output->Name = L"nud_L4_Output";
			this->nud_L4_Output->Size = System::Drawing::Size(96, 53);
			this->nud_L4_Output->TabIndex = 1;
			this->nud_L4_Output->TabStop = false;
			this->nud_L4_Output->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->nud_L4_Output->ValueChanged += gcnew System::EventHandler(this, &MyForm::nud_L4_Output_ValueChanged);
			// 
			// lb_L4_Output
			// 
			this->lb_L4_Output->AutoSize = true;
			this->lb_L4_Output->ForeColor = System::Drawing::Color::Blue;
			this->lb_L4_Output->Location = System::Drawing::Point(8, 8);
			this->lb_L4_Output->Name = L"lb_L4_Output";
			this->lb_L4_Output->Size = System::Drawing::Size(91, 18);
			this->lb_L4_Output->TabIndex = 0;
			this->lb_L4_Output->Text = L"Output (mA)";
			// 
			// pn_L4_Set
			// 
			this->pn_L4_Set->BackColor = System::Drawing::Color::DarkGray;
			this->pn_L4_Set->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L4_Set->Controls->Add(this->btn_L4);
			this->pn_L4_Set->Controls->Add(this->pn_L4_LED);
			this->pn_L4_Set->Controls->Add(this->ckb_L4_EXT);
			this->pn_L4_Set->Controls->Add(this->cbb_L4_MaxC);
			this->pn_L4_Set->Controls->Add(this->lb_L4_MaxC);
			this->pn_L4_Set->Location = System::Drawing::Point(12, 22);
			this->pn_L4_Set->Name = L"pn_L4_Set";
			this->pn_L4_Set->Size = System::Drawing::Size(194, 102);
			this->pn_L4_Set->TabIndex = 0;
			// 
			// btn_L4
			// 
			this->btn_L4->BackColor = System::Drawing::Color::LightGray;
			this->btn_L4->Location = System::Drawing::Point(124, 27);
			this->btn_L4->Name = L"btn_L4";
			this->btn_L4->Size = System::Drawing::Size(56, 28);
			this->btn_L4->TabIndex = 4;
			this->btn_L4->TabStop = false;
			this->btn_L4->Text = L"ON";
			this->btn_L4->UseVisualStyleBackColor = false;
			this->btn_L4->Click += gcnew System::EventHandler(this, &MyForm::btn_L4_Click);
			// 
			// pn_L4_LED
			// 
			this->pn_L4_LED->BackColor = System::Drawing::Color::Black;
			this->pn_L4_LED->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->pn_L4_LED->ForeColor = System::Drawing::Color::White;
			this->pn_L4_LED->Location = System::Drawing::Point(124, 12);
			this->pn_L4_LED->Name = L"pn_L4_LED";
			this->pn_L4_LED->Size = System::Drawing::Size(54, 12);
			this->pn_L4_LED->TabIndex = 3;
			// 
			// ckb_L4_EXT
			// 
			this->ckb_L4_EXT->AutoSize = true;
			this->ckb_L4_EXT->ForeColor = System::Drawing::Color::Maroon;
			this->ckb_L4_EXT->Location = System::Drawing::Point(10, 68);
			this->ckb_L4_EXT->Name = L"ckb_L4_EXT";
			this->ckb_L4_EXT->Size = System::Drawing::Size(177, 22);
			this->ckb_L4_EXT->TabIndex = 2;
			this->ckb_L4_EXT->TabStop = false;
			this->ckb_L4_EXT->Text = L"EXT. ON/OFF Control";
			this->ckb_L4_EXT->UseVisualStyleBackColor = true;
			this->ckb_L4_EXT->CheckedChanged += gcnew System::EventHandler(this, &MyForm::ckb_L4_EXT_CheckedChanged);
			// 
			// cbb_L4_MaxC
			// 
			this->cbb_L4_MaxC->BackColor = System::Drawing::Color::Black;
			this->cbb_L4_MaxC->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbb_L4_MaxC->DropDownWidth = 96;
			this->cbb_L4_MaxC->FlatStyle = System::Windows::Forms::FlatStyle::Popup;
			this->cbb_L4_MaxC->Font = (gcnew System::Drawing::Font(L"Arial", 20, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->cbb_L4_MaxC->ForeColor = System::Drawing::Color::Yellow;
			this->cbb_L4_MaxC->FormattingEnabled = true;
			this->cbb_L4_MaxC->Items->AddRange(gcnew cli::array< System::Object^  >(4) { L" 500mA", L" 600mA", L" 700mA", L" 800mA" });
			this->cbb_L4_MaxC->Location = System::Drawing::Point(10, 28);
			this->cbb_L4_MaxC->MaxDropDownItems = 4;
			this->cbb_L4_MaxC->Name = L"cbb_L4_MaxC";
			this->cbb_L4_MaxC->Size = System::Drawing::Size(96, 32);
			this->cbb_L4_MaxC->TabIndex = 1;
			this->cbb_L4_MaxC->TabStop = false;
			this->cbb_L4_MaxC->SelectedIndexChanged += gcnew System::EventHandler(this, &MyForm::cbb_L4_MaxC_SelectedIndexChanged);
			// 
			// lb_L4_MaxC
			// 
			this->lb_L4_MaxC->AutoSize = true;
			this->lb_L4_MaxC->ForeColor = System::Drawing::Color::Maroon;
			this->lb_L4_MaxC->Location = System::Drawing::Point(8, 8);
			this->lb_L4_MaxC->Name = L"lb_L4_MaxC";
			this->lb_L4_MaxC->Size = System::Drawing::Size(96, 18);
			this->lb_L4_MaxC->TabIndex = 0;
			this->lb_L4_MaxC->Text = L"Max. Current";
			// 
			// lb_PWR_ERR
			// 
			this->lb_PWR_ERR->AutoSize = true;
			this->lb_PWR_ERR->BackColor = System::Drawing::Color::Black;
			this->lb_PWR_ERR->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->lb_PWR_ERR->Font = (gcnew System::Drawing::Font(L"Arial", 16, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->lb_PWR_ERR->ForeColor = System::Drawing::Color::Gray;
			this->lb_PWR_ERR->Location = System::Drawing::Point(12, 324);
			this->lb_PWR_ERR->MaximumSize = System::Drawing::Size(122, 25);
			this->lb_PWR_ERR->MinimumSize = System::Drawing::Size(122, 25);
			this->lb_PWR_ERR->Name = L"lb_PWR_ERR";
			this->lb_PWR_ERR->Size = System::Drawing::Size(122, 25);
			this->lb_PWR_ERR->TabIndex = 11;
			this->lb_PWR_ERR->Text = L"Power Error";
			this->lb_PWR_ERR->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->lb_PWR_ERR->UseMnemonic = false;
			// 
			// gpb_ON_OFF
			// 
			this->gpb_ON_OFF->Controls->Add(this->cbb_SYNC_EN);
			this->gpb_ON_OFF->Enabled = false;
			this->gpb_ON_OFF->Location = System::Drawing::Point(12, 365);
			this->gpb_ON_OFF->Name = L"gpb_ON_OFF";
			this->gpb_ON_OFF->Size = System::Drawing::Size(122, 72);
			this->gpb_ON_OFF->TabIndex = 12;
			this->gpb_ON_OFF->TabStop = false;
			this->gpb_ON_OFF->Text = L"ON/OFF";
			// 
			// cbb_SYNC_EN
			// 
			this->cbb_SYNC_EN->BackColor = System::Drawing::Color::Black;
			this->cbb_SYNC_EN->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbb_SYNC_EN->DropDownWidth = 96;
			this->cbb_SYNC_EN->FlatStyle = System::Windows::Forms::FlatStyle::Popup;
			this->cbb_SYNC_EN->Font = (gcnew System::Drawing::Font(L"Arial", 20, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->cbb_SYNC_EN->ForeColor = System::Drawing::Color::Magenta;
			this->cbb_SYNC_EN->FormattingEnabled = true;
			this->cbb_SYNC_EN->Items->AddRange(gcnew cli::array< System::Object^  >(4) { L"ASYNC", L"SYNC2", L"SYNC3", L"SYNC4" });
			this->cbb_SYNC_EN->Location = System::Drawing::Point(12, 26);
			this->cbb_SYNC_EN->MaxDropDownItems = 4;
			this->cbb_SYNC_EN->Name = L"cbb_SYNC_EN";
			this->cbb_SYNC_EN->Size = System::Drawing::Size(96, 32);
			this->cbb_SYNC_EN->TabIndex = 0;
			this->cbb_SYNC_EN->TabStop = false;
			this->cbb_SYNC_EN->SelectedIndexChanged += gcnew System::EventHandler(this, &MyForm::cbb_SYNC_EN_SelectedIndexChanged);
			// 
			// MyForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(9, 18);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::Silver;
			this->ClientSize = System::Drawing::Size(892, 512);
			this->Controls->Add(this->gpb_ON_OFF);
			this->Controls->Add(this->lb_PWR_ERR);
			this->Controls->Add(this->lb_L4);
			this->Controls->Add(this->gpb_L4);
			this->Controls->Add(this->lb_L3);
			this->Controls->Add(this->gpb_L3);
			this->Controls->Add(this->lb_L2);
			this->Controls->Add(this->gpb_L2);
			this->Controls->Add(this->lb_L1);
			this->Controls->Add(this->gpb_L1);
			this->Controls->Add(this->richTextBox);
			this->Controls->Add(this->pn_Port);
			this->Controls->Add(this->statusStrip);
			this->Font = (gcnew System::Drawing::Font(L"Arial", 16, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Pixel,
				static_cast<System::Byte>(0)));
			this->Margin = System::Windows::Forms::Padding(4);
			this->MaximizeBox = false;
			this->Name = L"MyForm";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"PM-24084R (VC)";
			this->Load += gcnew System::EventHandler(this, &MyForm::MyForm_Load);
			this->statusStrip->ResumeLayout(false);
			this->statusStrip->PerformLayout();
			this->pn_Port->ResumeLayout(false);
			this->pn_Port->PerformLayout();
			this->gpb_L1->ResumeLayout(false);
			this->pn_L1_Output->ResumeLayout(false);
			this->pn_L1_Output->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->tkb_L1_Output))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nud_L1_Output))->EndInit();
			this->pn_L1_Set->ResumeLayout(false);
			this->pn_L1_Set->PerformLayout();
			this->gpb_L2->ResumeLayout(false);
			this->pn_L2_Output->ResumeLayout(false);
			this->pn_L2_Output->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->tkb_L2_Output))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nud_L2_Output))->EndInit();
			this->pn_L2_Set->ResumeLayout(false);
			this->pn_L2_Set->PerformLayout();
			this->gpb_L3->ResumeLayout(false);
			this->pn_L3_Output->ResumeLayout(false);
			this->pn_L3_Output->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->tkb_L3_Output))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nud_L3_Output))->EndInit();
			this->pn_L3_Set->ResumeLayout(false);
			this->pn_L3_Set->PerformLayout();
			this->gpb_L4->ResumeLayout(false);
			this->pn_L4_Output->ResumeLayout(false);
			this->pn_L4_Output->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->tkb_L4_Output))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->nud_L4_Output))->EndInit();
			this->pn_L4_Set->ResumeLayout(false);
			this->pn_L4_Set->PerformLayout();
			this->gpb_ON_OFF->ResumeLayout(false);
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	// #########################################################################

	private: System::Void MyForm_Load(System::Object^  sender, System::EventArgs^  e)
	{
		MaxCurrent[0] = 500;
		MaxCurrent[1] = 600;
		MaxCurrent[2] = 700;
		MaxCurrent[3] = 800;
		cbb_L1_MaxC->SelectedIndex = 0;                 // 500mA
		cbb_L2_MaxC->SelectedIndex = 0;                 // 500mA
		cbb_L3_MaxC->SelectedIndex = 0;                 // 500mA
		cbb_L4_MaxC->SelectedIndex = 0;                 // 500mA
		cbb_SYNC_EN->SelectedIndex = ASYNC;             // ASYNC
		COMPort_Check();                                // C˪
	}

	// RichTextBox *************************************************************

	void Dsp_String(Color text_color, String^ str)      // ܦr
	{
		if (++Line_CTR > Lines_Max)
		{
			Line_CTR = 1;
			richTextBox->Clear();
		}
		if (Line_CTR > 1) richTextBox->AppendText("\n");
		richTextBox->SelectionStart = richTextBox->Text->Length;
		richTextBox->ScrollToCaret();
		richTextBox->SelectionBackColor = Color::Gainsboro;
		richTextBox->SelectionColor = SystemColors::WindowText;
		richTextBox->AppendText(String::Format("{0:X4}", Line_No++));
		richTextBox->SelectionBackColor = SystemColors::Window;
		richTextBox->SelectionColor = text_color;
		richTextBox->AppendText(" " + str);
		richTextBox->Select();
	}

	void Dsp_TX_Packet(Color text_color, Byte length, Byte counter)  //  TX ʥ]
	{
		if (++Line_CTR > Lines_Max)
		{
			Line_CTR = 1;
			richTextBox->Clear();
		}
		if (Line_CTR > 1) richTextBox->AppendText("\n");
		richTextBox->SelectionStart = richTextBox->Text->Length;
		richTextBox->ScrollToCaret();
		richTextBox->SelectionBackColor = Color::Gainsboro;
		richTextBox->SelectionColor = SystemColors::WindowText;
		richTextBox->AppendText(String::Format("{0:X4}", Line_No++));
		richTextBox->SelectionBackColor = SystemColors::Window;
		richTextBox->SelectionColor = text_color;

		String^ str = " TX:";
		for (Byte i = 0; i < length; i++) str += String::Format(" {0:X2}", TX_Packet[i]);
		str += " (" + Convert::ToString(counter) + ")";
		richTextBox->AppendText(str);
		richTextBox->Select();
	}

	void Dsp_RX_Packet(Color text_color, Byte length)   //  RX ʥ]
	{
		if (++Line_CTR > Lines_Max)
		{
			Line_CTR = 1;
			richTextBox->Clear();
		}
		if (Line_CTR > 1) richTextBox->AppendText("\n");
		richTextBox->SelectionStart = richTextBox->Text->Length;
		richTextBox->ScrollToCaret();
		richTextBox->SelectionBackColor = Color::Gainsboro;
		richTextBox->SelectionColor = SystemColors::WindowText;
		richTextBox->AppendText(String::Format("{0:X4}", Line_No++));
		richTextBox->SelectionBackColor = SystemColors::Window;
		richTextBox->SelectionColor = text_color;

		String^ str = " RX:";
		for (Byte i = 0; i < length; i++) str += String::Format(" {0:X2}", RX_Packet[i]);
		richTextBox->AppendText(str);
		richTextBox->Select();
	}

	// L1: Xվ ************************************************************

	private: System::Void cbb_L1_MaxC_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
	{
		Byte iMaxC = cbb_L1_MaxC->SelectedIndex;
		if (iMaxC != ((L1_Set >> 4) & 0x03))
		{
			Byte v = L1_Set & (SET_EXT_CTRL | SET_ON_OFF);
			L1_Set = (iMaxC << 4) | v;

			int MaxC = MaxCurrent[iMaxC];
			L1_Output = 0;
			nud_L1_Output->Value = 0;
			nud_L1_Output->Maximum = MaxC;
			tkb_L1_Output->Value = 0;
			tkb_L1_Output->Maximum = MaxC;
			tkb_L1_Output->TickFrequency = MaxC / 10;
			lb_L1_PCV->Text = "0.0";
			L1_Output_CHG = false;

			if (READ_Flag == true) L1_Set_CHG = true;
		}
	}

	private: System::Void nud_L1_Output_ValueChanged(System::Object^  sender, System::EventArgs^  e)
	{
		L1_Output = (int)nud_L1_Output->Value;
		tkb_L1_Output->Value = L1_Output;
		int MaxC = MaxCurrent[cbb_L1_MaxC->SelectedIndex];
		lb_L1_PCV->Text = String::Format("{0:F1}", (float)(L1_Output * 100) / MaxC);

		if (READ_Flag == true) L1_Output_CHG = true;
	}

	private: System::Void tkb_L1_Output_ValueChanged(System::Object^  sender, System::EventArgs^  e)
	{
		L1_Output = tkb_L1_Output->Value;
		nud_L1_Output->Value = L1_Output;
		int MaxC = MaxCurrent[cbb_L1_MaxC->SelectedIndex];
		lb_L1_PCV->Text = String::Format("{0:F1}", (float)(L1_Output * 100) / MaxC);

		if (READ_Flag == true) L1_Output_CHG = true;
	}

	// L1: ON/OFF ==============================================================

	private: System::Void ckb_L1_EXT_CheckedChanged(System::Object^  sender, System::EventArgs^  e)
	{
		if (ckb_L1_EXT->Checked == false)               // Checked to Unchecked ?
		{
			L1_Set &= (SET_EXT_CTRL ^ 0xFF);            // L1: EXT. ON/OFF Control = Unchecked
			pn_L1_LED->Visible = true;
			btn_L1->Visible = true;

			if (SYNC_EN > ASYNC) ckb_L2_EXT->Checked = false;  // L2: EXT. ON/OFF Control = Unchecked
			if (SYNC_EN > SYNC2) ckb_L3_EXT->Checked = false;  // L3: EXT. ON/OFF Control = Unchecked
			if (SYNC_EN > SYNC3) ckb_L4_EXT->Checked = false;  // L4: EXT. ON/OFF Control = Unchecked
		}
		else                                            // Unchecked to Checked
		{
			L1_Set |= SET_EXT_CTRL;                     // L1: EXT. ON/OFF Control = Checked
			pn_L1_LED->Visible = false;
			btn_L1->Visible = false;

			if (SYNC_EN > ASYNC) ckb_L2_EXT->Checked = true;   // L2: EXT. ON/OFF Control = Checked
			if (SYNC_EN > SYNC2) ckb_L3_EXT->Checked = true;   // L3: EXT. ON/OFF Control = Checked
			if (SYNC_EN > SYNC3) ckb_L4_EXT->Checked = true;   // L4: EXT. ON/OFF Control = Checked
		}

		if (READ_Flag == true) L1_Set_CHG = true;
	}

	private: System::Void btn_L1_Click(System::Object^  sender, System::EventArgs^  e)
	{
		if ((L1_Set & SET_ON_OFF) == SET_ON_OFF)        // ON to OFF ?
		{
			L1_Set &= (SET_ON_OFF ^ 0xFF);              // L1: ON/OFF = OFF
			pn_L1_LED->BackColor = Color::Black;
			btn_L1->Text = "ON";

			if (SYNC_EN > ASYNC)
			{
				L2_Set &= (SET_ON_OFF ^ 0xFF);          // L2: ON/OFF = OFF
				pn_L2_LED->BackColor = pn_L1_LED->BackColor;
				btn_L2->Text = btn_L1->Text;
			}
			if (SYNC_EN > SYNC2)
			{
				L3_Set &= (SET_ON_OFF ^ 0xFF);          // L3: ON/OFF = OFF
				pn_L3_LED->BackColor = pn_L1_LED->BackColor;
				btn_L3->Text = btn_L1->Text;
			}
			if (SYNC_EN > SYNC3)
			{
				L4_Set &= (SET_ON_OFF ^ 0xFF);          // L4: ON/OFF = OFF
				pn_L4_LED->BackColor = pn_L1_LED->BackColor;
				btn_L4->Text = btn_L1->Text;
			}
		}
		else                                            // OFF to ON
		{
			L1_Set |= SET_ON_OFF;                       // L1: ON/OFF = ON
			pn_L1_LED->BackColor = Color::Green;
			btn_L1->Text = "OFF";

			if (SYNC_EN > ASYNC)
			{
				L2_Set |= SET_ON_OFF;                   // L2: ON/OFF = ON
				pn_L2_LED->BackColor = pn_L1_LED->BackColor;
				btn_L2->Text = btn_L1->Text;
			}
			if (SYNC_EN > SYNC2)
			{
				L3_Set |= SET_ON_OFF;                   // L3: ON/OFF = ON
				pn_L3_LED->BackColor = pn_L1_LED->BackColor;
				btn_L3->Text = btn_L1->Text;
			}
			if (SYNC_EN > SYNC3)
			{
				L4_Set |= SET_ON_OFF;                   // L4: ON/OFF = ON
				pn_L4_LED->BackColor = pn_L1_LED->BackColor;
				btn_L4->Text = btn_L1->Text;
			}
		}

		if (READ_Flag == true) L1_ON_OFF_CHG = true;
	}

	// L2: Xվ ************************************************************

	private: System::Void cbb_L2_MaxC_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
	{
		Byte iMaxC = cbb_L2_MaxC->SelectedIndex;
		if (iMaxC != ((L2_Set >> 4) & 0x03))
		{
			Byte v = L2_Set & (SET_EXT_CTRL | SET_ON_OFF);
			L2_Set = (iMaxC << 4) | v;

			int MaxC = MaxCurrent[iMaxC];
			L2_Output = 0;
			nud_L2_Output->Value = 0;
			nud_L2_Output->Maximum = MaxC;
			tkb_L2_Output->Value = 0;
			tkb_L2_Output->Maximum = MaxC;
			tkb_L2_Output->TickFrequency = MaxC / 10;
			lb_L2_PCV->Text = "0.0";
			L2_Output_CHG = false;

			if (READ_Flag == true) L2_Set_CHG = true;
		}
	}

	private: System::Void nud_L2_Output_ValueChanged(System::Object^  sender, System::EventArgs^  e)
	{
		L2_Output = (int)nud_L2_Output->Value;
		tkb_L2_Output->Value = L2_Output;
		int MaxC = MaxCurrent[cbb_L2_MaxC->SelectedIndex];
		lb_L2_PCV->Text = String::Format("{0:F1}", (float)(L2_Output * 100) / MaxC);

		if (READ_Flag == true) L2_Output_CHG = true;
	}

	private: System::Void tkb_L2_Output_ValueChanged(System::Object^  sender, System::EventArgs^  e)
	{
		L2_Output = tkb_L2_Output->Value;
		nud_L2_Output->Value = L2_Output;
		int MaxC = MaxCurrent[cbb_L2_MaxC->SelectedIndex];
		lb_L2_PCV->Text = String::Format("{0:F1}", (float)(L2_Output * 100) / MaxC);

		if (READ_Flag == true) L2_Output_CHG = true;
	}

	// L2: ON/OFF ==============================================================

	private: System::Void ckb_L2_EXT_CheckedChanged(System::Object^  sender, System::EventArgs^  e)
	{
		if (ckb_L2_EXT->Checked == false)               // Checked to Unchecked ?
		{
			L2_Set &= (SET_EXT_CTRL ^ 0xFF);            // L2: EXT. ON/OFF Control = Unchecked
			pn_L2_LED->Visible = true;
			btn_L2->Visible = true;
		}
		else                                            // Unchecked to Checked
		{
			L2_Set |= SET_EXT_CTRL;                     // L2: EXT. ON/OFF Control = Checked
			pn_L2_LED->Visible = false;
			btn_L2->Visible = false;
		}

		if ((READ_Flag == true) && (SYNC_EN < SYNC2)) L2_Set_CHG = true;
	}

	private: System::Void btn_L2_Click(System::Object^  sender, System::EventArgs^  e)
	{
		if ((L2_Set & SET_ON_OFF) == SET_ON_OFF)        // ON to OFF ?
		{
			L2_Set &= (SET_ON_OFF ^ 0xFF);              // L2: ON/OFF = OFF
			pn_L2_LED->BackColor = Color::Black;
			btn_L2->Text = "ON";
		}
		else                                            // OFF to ON
		{
			L2_Set |= SET_ON_OFF;                       // L2: ON/OFF = ON
			pn_L2_LED->BackColor = Color::Green;
			btn_L2->Text = "OFF";
		}

		if ((READ_Flag == true) && (SYNC_EN < SYNC2)) L2_ON_OFF_CHG = true;
	}

	// L3: Xվ ************************************************************

	private: System::Void cbb_L3_MaxC_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
	{
		Byte iMaxC = cbb_L3_MaxC->SelectedIndex;
		if (iMaxC != ((L3_Set >> 4) & 0x03))
		{
			Byte v = L3_Set & (SET_EXT_CTRL | SET_ON_OFF);
			L3_Set = (iMaxC << 4) | v;

			int MaxC = MaxCurrent[iMaxC];
			L3_Output = 0;
			nud_L3_Output->Value = 0;
			nud_L3_Output->Maximum = MaxC;
			tkb_L3_Output->Value = 0;
			tkb_L3_Output->Maximum = MaxC;
			tkb_L3_Output->TickFrequency = MaxC / 10;
			lb_L3_PCV->Text = "0.0";
			L3_Output_CHG = false;

			if (READ_Flag == true) L3_Set_CHG = true;
		}
	}

	private: System::Void nud_L3_Output_ValueChanged(System::Object^  sender, System::EventArgs^  e)
	{
		L3_Output = (int)nud_L3_Output->Value;
		tkb_L3_Output->Value = L3_Output;
		int MaxC = MaxCurrent[cbb_L3_MaxC->SelectedIndex];
		lb_L3_PCV->Text = String::Format("{0:F1}", (float)(L3_Output * 100) / MaxC);

		if (READ_Flag == true) L3_Output_CHG = true;
	}

	private: System::Void tkb_L3_Output_ValueChanged(System::Object^  sender, System::EventArgs^  e)
	{
		L3_Output = tkb_L3_Output->Value;
		nud_L3_Output->Value = L3_Output;
		int MaxC = MaxCurrent[cbb_L3_MaxC->SelectedIndex];
		lb_L3_PCV->Text = String::Format("{0:F1}", (float)(L3_Output * 100) / MaxC);

		if (READ_Flag == true) L3_Output_CHG = true;
	}

	// L3: ON/OFF ==============================================================

	private: System::Void ckb_L3_EXT_CheckedChanged(System::Object^  sender, System::EventArgs^  e)
	{
		if (ckb_L3_EXT->Checked == false)               // Checked to Unchecked ?
		{
			L3_Set &= (SET_EXT_CTRL ^ 0xFF);            // L3: EXT. ON/OFF Control = Unchecked
			pn_L3_LED->Visible = true;
			btn_L3->Visible = true;
		}
		else                                            // Unchecked to Checked
		{
			L3_Set |= SET_EXT_CTRL;                     // L3: EXT. ON/OFF Control = Checked
			pn_L3_LED->Visible = false;
			btn_L3->Visible = false;
		}

		if ((READ_Flag == true) && (SYNC_EN < SYNC3)) L3_Set_CHG = true;
	}

	private: System::Void btn_L3_Click(System::Object^  sender, System::EventArgs^  e)
	{
		if ((L3_Set & SET_ON_OFF) == SET_ON_OFF)        // ON to OFF ?
		{
			L3_Set &= (SET_ON_OFF ^ 0xFF);              // L3: ON/OFF = OFF
			pn_L3_LED->BackColor = Color::Black;
			btn_L3->Text = "ON";
		}
		else                                            // OFF to ON
		{
			L3_Set |= SET_ON_OFF;                       // L3: ON/OFF = ON
			pn_L3_LED->BackColor = Color::Green;
			btn_L3->Text = "OFF";
		}

		if ((READ_Flag == true) && (SYNC_EN < SYNC3)) L3_ON_OFF_CHG = true;
	}

	// L4: Xվ ************************************************************

	private: System::Void cbb_L4_MaxC_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
	{
		Byte iMaxC = cbb_L4_MaxC->SelectedIndex;
		if (iMaxC != ((L4_Set >> 4) & 0x03))
		{
			Byte v = L4_Set & (SET_EXT_CTRL | SET_ON_OFF);
			L4_Set = (iMaxC << 4) | v;

			int MaxC = MaxCurrent[iMaxC];
			L4_Output = 0;
			nud_L4_Output->Value = 0;
			nud_L4_Output->Maximum = MaxC;
			tkb_L4_Output->Value = 0;
			tkb_L4_Output->Maximum = MaxC;
			tkb_L4_Output->TickFrequency = MaxC / 10;
			lb_L4_PCV->Text = "0.0";
			L4_Output_CHG = false;

			if (READ_Flag == true) L4_Set_CHG = true;
		}
	}

	private: System::Void nud_L4_Output_ValueChanged(System::Object^  sender, System::EventArgs^  e)
	{
		L4_Output = (int)nud_L4_Output->Value;
		tkb_L4_Output->Value = L4_Output;
		int MaxC = MaxCurrent[cbb_L4_MaxC->SelectedIndex];
		lb_L4_PCV->Text = String::Format("{0:F1}", (float)(L4_Output * 100) / MaxC);

		if (READ_Flag == true) L4_Output_CHG = true;
	}

	private: System::Void tkb_L4_Output_ValueChanged(System::Object^  sender, System::EventArgs^  e)
	{
		L4_Output = tkb_L4_Output->Value;
		nud_L4_Output->Value = L4_Output;
		int MaxC = MaxCurrent[cbb_L4_MaxC->SelectedIndex];
		lb_L4_PCV->Text = String::Format("{0:F1}", (float)(L4_Output * 100) / MaxC);

		if (READ_Flag == true) L4_Output_CHG = true;
	}

	// L4: ON/OFF ==============================================================

	private: System::Void ckb_L4_EXT_CheckedChanged(System::Object^  sender, System::EventArgs^  e)
	{
		if (ckb_L4_EXT->Checked == false)               // Checked to Unchecked ?
		{
			L4_Set &= (SET_EXT_CTRL ^ 0xFF);            // L4: EXT. ON/OFF Control = Unchecked
			pn_L4_LED->Visible = true;
			btn_L4->Visible = true;
		}
		else                                            // Unchecked to Checked
		{
			L4_Set |= SET_EXT_CTRL;                     // L4: EXT. ON/OFF Control = Checked
			pn_L4_LED->Visible = false;
			btn_L4->Visible = false;
		}

		if ((READ_Flag == true) && (SYNC_EN != SYNC4)) L4_Set_CHG = true;
	}

	private: System::Void btn_L4_Click(System::Object^  sender, System::EventArgs^  e)
	{
		if ((L4_Set & SET_ON_OFF) == SET_ON_OFF)        // ON to OFF ?
		{
			L4_Set &= (SET_ON_OFF ^ 0xFF);              // L4: ON/OFF = OFF
			pn_L4_LED->BackColor = Color::Black;
			btn_L4->Text = "ON";
		}
		else                                            // OFF to ON
		{
			L4_Set |= SET_ON_OFF;                       // L4: ON/OFF = ON
			pn_L4_LED->BackColor = Color::Green;
			btn_L4->Text = "OFF";
		}

		if ((READ_Flag == true) && (SYNC_EN != SYNC4)) L4_ON_OFF_CHG = true;
	}

	// SYNC Enable *************************************************************

	private: System::Void cbb_SYNC_EN_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
	{
		SystemSounds::Exclamation->Play();
		Byte vAND = (SET_EXT_CTRL | SET_ON_OFF) ^ 0xFF;
		Byte vOR = (SET_EXT_CTRL | SET_ON_OFF) & L1_Set;
		SYNC_EN = cbb_SYNC_EN->SelectedIndex;

		if (SYNC_EN > ASYNC)
		{
			L2_Set = (L2_Set & vAND) | vOR;
			ckb_L2_EXT->Enabled = false;
			ckb_L2_EXT->Checked = ckb_L1_EXT->Checked;
			pn_L2_LED->BackColor = pn_L1_LED->BackColor;
			pn_L2_LED->Visible = pn_L1_LED->Visible;
			btn_L2->Enabled = false;
			btn_L2->Text = btn_L1->Text;
			btn_L2->Visible = btn_L1->Visible;
		}
		else
		{
			if (!(ACK_State & AS_L2_ERR))
			{
				ckb_L2_EXT->Enabled = true;
				btn_L2->Enabled = true;
			}
		}

		if (SYNC_EN > SYNC2)
		{
			L3_Set = (L3_Set & vAND) | vOR;
			ckb_L3_EXT->Enabled = false;
			ckb_L3_EXT->Checked = ckb_L1_EXT->Checked;
			pn_L3_LED->BackColor = pn_L1_LED->BackColor;
			pn_L3_LED->Visible = pn_L1_LED->Visible;
			btn_L3->Enabled = false;
			btn_L3->Text = btn_L1->Text;
			btn_L3->Visible = btn_L1->Visible;
		}
		else
		{
			if (!(ACK_State & AS_L3_ERR))
			{
				ckb_L3_EXT->Enabled = true;
				btn_L3->Enabled = true;
			}
		}

		if (SYNC_EN > SYNC3)
		{
			L4_Set = (L4_Set & vAND) | vOR;
			ckb_L4_EXT->Enabled = false;
			ckb_L4_EXT->Checked = ckb_L1_EXT->Checked;
			pn_L4_LED->BackColor = pn_L1_LED->BackColor;
			pn_L4_LED->Visible = pn_L1_LED->Visible;
			btn_L4->Enabled = false;
			btn_L4->Text = btn_L1->Text;
			btn_L4->Visible = btn_L1->Visible;
		}
		else
		{
			if (!(ACK_State & AS_L4_ERR))
			{
				ckb_L4_EXT->Enabled = true;
				btn_L4->Enabled = true;
			}
		}

		if (READ_Flag == true) SYNC_EN_CHG = true;
	}

	// Serial Port *************************************************************

	private: System::Void cbb_PortNo_Click(System::Object^  sender, System::EventArgs^  e)
	{
		COMPort_Check();                                // C˪
	}

	private: System::Void btn_Connect_Click(System::Object^  sender, System::EventArgs^  e)
	{
		bool state = false;

		if (serialPort->IsOpen)                         // CO_w}?
		{
			COMPort_Disconnect();                       // Cu
		}
		else
		{
			PortNo = SerialPort::GetPortNames();        // osb COM Port.
			if (PortNo->Length >= 1)
			{
				if (cbb_PortNo->Text == "")
				{
					Dsp_String(Color::Red, "ܦC!");
					SystemSounds::Exclamation->Play();
				}
				else
				{
					for each (String^ port in PortNo)
					{
						if (port == cbb_PortNo->Text)
						{
							state = true;
							break;
						}
					}
					if (state == true)
					{
						if (serialPort->IsOpen)
						{
							COMPort_Disconnect();       // Cu
						}
						else
						{
							COMPort_Connect();          // Csu
							if (PORT_Flag == true)
							{
								TX_Read_Data();         // ǰe: Read Data
							}
						}
					}
				}
			}
			else
			{
				cbb_PortNo->Items->Clear();             // M ComboBox->Items e.
				Dsp_String(Color::Red, "o{C!");
				SystemSounds::Exclamation->Play();
			}
		}
	}

	void COMPort_Check()                                // C˪
	{
		String^ Port_No = cbb_PortNo->Text;
		
		PortNo = SerialPort::GetPortNames();            // osb COM Port.
		cbb_PortNo->Items->Clear();                     // M ComboBox->Items e.
		if (PortNo->Length >= 1)
		{
			for each(String^ port in PortNo)            // N쪺{ COM Port [J ComboBox->Items
			{
				cbb_PortNo->Items->Add(port);
				if (port == Port_No) cbb_PortNo->Text = Port_No;
			}
			
			if (cbb_PortNo->Text == "")
			{
				cbb_PortNo->Text = PortNo[0];           // ComboBox->Text ܤ@Ӳ{s COM Port.
			}
		}
		else
		{
			Dsp_String(Color::Red, "o{C!");
			SystemSounds::Exclamation->Play();
		}
	}

	void COMPort_Connect()                              // Csu
	{
		TX_Flag = RX_Flag = PORT_Flag = false;
		TX_CMD = TX_CTR = RX_Index = 0;
		SYNC_EN_CHG = false;
		L1_Set_CHG = L1_Output_CHG = L1_ON_OFF_CHG = false;
		L2_Set_CHG = L2_Output_CHG = L2_ON_OFF_CHG = false;
		L3_Set_CHG = L3_Output_CHG = L3_ON_OFF_CHG = false;
		L4_Set_CHG = L4_Output_CHG = L4_ON_OFF_CHG = false;
		serialPort->PortName = cbb_PortNo->Text;

		try
		{
			serialPort->Open();                         // }ҷsǦCsu.
			serialPort->DiscardInBuffer();              // ˱ǦCXʵ{wİϪ.
			serialPort->DiscardOutBuffer();             // ˱ǦCXʵ{ǿwİϪ.
			cbb_PortNo->Enabled = false;
			btn_Connect->Text = "Disconnect";
			tss_Status->Text = "Connect";
			Dsp_String(Color::Magenta, cbb_PortNo->Text + " connect.");
			PORT_Flag = true;
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
		}
	}

	void COMPort_Disconnect()                           // Cu
	{
		TX_Flag = RX_Flag = PORT_Flag = false;
		TX_CMD = TX_CTR = RX_Index = ACK_State = 0;
		SYNC_EN_CHG = false;
		L1_Set_CHG = L1_Output_CHG = L1_ON_OFF_CHG = false;
		L2_Set_CHG = L2_Output_CHG = L2_ON_OFF_CHG = false;
		L3_Set_CHG = L3_Output_CHG = L3_ON_OFF_CHG = false;
		L4_Set_CHG = L4_Output_CHG = L4_ON_OFF_CHG = false;

		try
		{
			serialPort->Close();                        // ssu.
			Dsp_String(Color::Magenta, cbb_PortNo->Text + " disconnect.");
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			COMPort_Check();                            // C˪
		}

		cbb_PortNo->Enabled = true;
		btn_Connect->Text = "Connect";
		tss_Status->Text = "Disconnect";
		lb_L1->Text = "L1";
		lb_L2->Text = "L2";
		lb_L3->Text = "L3";
		lb_L4->Text = "L4";
		lb_L1->BackColor = Color::Black;
		lb_L2->BackColor = Color::Black;
		lb_L3->BackColor = Color::Black;
		lb_L4->BackColor = Color::Black;
		lb_PWR_ERR->ForeColor = Color::Gray;
		lb_PWR_ERR->BackColor = Color::Black;
		gpb_ON_OFF->Enabled = false;
		gpb_L1->Enabled = false;
		gpb_L2->Enabled = false;
		gpb_L3->Enabled = false;
		gpb_L4->Enabled = false;
	}

	// Serial Port: RX *********************************************************

	private: System::Void serialPort_DataReceived(System::Object^  sender, System::IO::Ports::SerialDataReceivedEventArgs^  e)
	{
		int bytes = serialPort->BytesToRead;
		array<Byte>^ buffer = gcnew array<Byte>(bytes);

		if (bytes > 0)
		{
			serialPort->Read(buffer, 0, bytes);
			for (int i = 0; i < bytes; i++)
			{
				RX_Packet[RX_Index] = buffer[i];
				if (RX_Index == 0)                      // Header 'S'
				{
					if (RX_Packet[0] == 0x53) RX_Index++;
				}
				else
				{
					if (RX_Index == 1)                  // Header 'M'
					{
						if (RX_Packet[1] == 0x4D) RX_Index++;
						else RX_Index = 0;
					}
					else
					{
						if (RX_Index == 2)              // Packet Length
						{
							if ((RX_Packet[2] == 17) || (RX_Packet[2] == 5))
							{
								RX_Index++;
								RX_Length = RX_Packet[2];
							}
							else RX_Index = 0;
						}
						else
						{
							if (++RX_Index >= RX_Length)
							{
								RX_Index = 0;
								Byte n, checksum;
								for (n = checksum = 0; n < (RX_Length - 1); n++) checksum += RX_Packet[n];
								if (checksum == RX_Packet[n])
								{
									Packet_OK();        // ʥ]Ʈ榡 OK
								}
							}
						}
					}
				}
			}
		}
	}

	void Packet_OK()                                    // ʥ]Ʈ榡 OK
	{
		switch (TX_CMD)
		{
		case CMD_READ_DATA:
			if (RX_Length == 17) RX_Flag = true;
			break;
		case CMD_SYNC_EN:
		case CMD_L1_SET:
		case CMD_L2_SET:
		case CMD_L3_SET:
		case CMD_L4_SET:
		case CMD_L1_OUTPUT:
		case CMD_L2_OUTPUT:
		case CMD_L3_OUTPUT:
		case CMD_L4_OUTPUT:
		case CMD_L1_ON_OFF:
		case CMD_L2_ON_OFF:
		case CMD_L3_ON_OFF:
		case CMD_L4_ON_OFF:
			if (RX_Length == 5) RX_Flag = true;
			break;
		}
	}

	// Serial Port: TX *********************************************************

	void TX_Read_Data()                                 // ǰe: Read Data
	{
		Byte i, checksum;
		
		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 5;                           // Packet Length
			TX_Packet[3] = CMD_READ_DATA;               // Command
			for (i = checksum = 0; i < 4; i++) checksum += TX_Packet[i];
			TX_Packet[4] = checksum;                    // Checksum
			TX_CMD = CMD_READ_DATA;
			TX_CTR = 0;
			TX_Flag = true;
			READ_Flag = false;
		}
		
		if (TX_CTR == 0) Dsp_TX_Packet(Color::Black, 5, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 5, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;
		
		try
		{
			serialPort->Write(TX_Packet, 0, 5);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_SYNC_EN()                                   // ǰe: SYNC Enable
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 6;                           // Packet Length
			TX_Packet[3] = CMD_SYNC_EN;                 // Command
			TX_Packet[4] = SYNC_EN;
			for (i = checksum = 0; i < 5; i++) checksum += TX_Packet[i];
			TX_Packet[5] = checksum;                    // Checksum
			TX_CMD = CMD_SYNC_EN;
			TX_CTR = 0;
			TX_Flag = true;
			SYNC_EN_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Black, 6, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 6, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 6);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L1_Set()                                    // ǰe: L1 Set
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 6;                           // Packet Length
			TX_Packet[3] = CMD_L1_SET;                  // Command
			TX_Packet[4] = L1_Set;                      // L1 ]w
			for (i = checksum = 0; i < 5; i++) checksum += TX_Packet[i];
			TX_Packet[5] = checksum;                    // Checksum
			TX_CMD = CMD_L1_SET;
			TX_CTR = 0;
			TX_Flag = true;
			L1_Set_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Maroon, 6, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 6, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 6);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L2_Set()                                    // ǰe: L2 Set
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 6;                           // Packet Length
			TX_Packet[3] = CMD_L2_SET;                  // Command
			TX_Packet[4] = L2_Set;                      // L2 ]w
			for (i = checksum = 0; i < 5; i++) checksum += TX_Packet[i];
			TX_Packet[5] = checksum;                    // Checksum
			TX_CMD = CMD_L2_SET;
			TX_CTR = 0;
			TX_Flag = true;
			L2_Set_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Maroon, 6, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 6, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 6);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L3_Set()                                    // ǰe: L3 Set
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 6;                           // Packet Length
			TX_Packet[3] = CMD_L3_SET;                  // Command
			TX_Packet[4] = L3_Set;                      // L3 ]w
			for (i = checksum = 0; i < 5; i++) checksum += TX_Packet[i];
			TX_Packet[5] = checksum;                            // Checksum
			TX_CMD = CMD_L3_SET;
			TX_CTR = 0;
			TX_Flag = true;
			L3_Set_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Maroon, 6, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 6, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 6);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L4_Set()                                    // ǰe: L4 Set
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 6;                           // Packet Length
			TX_Packet[3] = CMD_L4_SET;                  // Command
			TX_Packet[4] = L4_Set;                      // L4 ]w
			for (i = checksum = 0; i < 5; i++) checksum += TX_Packet[i];
			TX_Packet[5] = checksum;                    // Checksum
			TX_CMD = CMD_L4_SET;
			TX_CTR = 0;
			TX_Flag = true;
			L4_Set_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Maroon, 6, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 6, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 6);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L1_Output()                                 // ǰe: L1 Output
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 7;                           // Packet Length
			TX_Packet[3] = CMD_L1_OUTPUT;               // Command
			TX_Packet[4] = L1_Output >> 8;              // L1 Output, HB
			TX_Packet[5] = L1_Output;                   // L1 Output, LB
			for (i = checksum = 0; i < 6; i++) checksum += TX_Packet[i];
			TX_Packet[6] = checksum;                    // Checksum
			TX_CMD = CMD_L1_OUTPUT;
			TX_CTR = 0;
			TX_Flag = true;
			L1_Output_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Blue, 7, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 7, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 7);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L2_Output()                                 // ǰe: L2 Output
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 7;                           // Packet Length
			TX_Packet[3] = CMD_L2_OUTPUT;               // Command
			TX_Packet[4] = L2_Output >> 8;              // L2 Output, HB
			TX_Packet[5] = L2_Output;                   // L2 Output, LB
			for (i = checksum = 0; i < 6; i++) checksum += TX_Packet[i];
			TX_Packet[6] = checksum;                    // Checksum
			TX_CMD = CMD_L2_OUTPUT;
			TX_CTR = 0;
			TX_Flag = true;
			L2_Output_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Blue, 7, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 7, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 7);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L3_Output()                                 // ǰe: L3 Output
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 7;                           // Packet Length
			TX_Packet[3] = CMD_L3_OUTPUT;               // Command
			TX_Packet[4] = L3_Output >> 8;              // L3 Output, HB
			TX_Packet[5] = L3_Output;                   // L3 Output, LB
			for (i = checksum = 0; i < 6; i++) checksum += TX_Packet[i];
			TX_Packet[6] = checksum;                    // Checksum
			TX_CMD = CMD_L3_OUTPUT;
			TX_CTR = 0;
			TX_Flag = true;
			L3_Output_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Blue, 7, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 7, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 7);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L4_Output()                                 // ǰe: L4 Output
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 7;                           // Packet Length
			TX_Packet[3] = CMD_L4_OUTPUT;               // Command
			TX_Packet[4] = L4_Output >> 8;              // L4 Output, HB
			TX_Packet[5] = L4_Output;                   // L4 Output, LB
			for (i = checksum = 0; i < 6; i++) checksum += TX_Packet[i];
			TX_Packet[6] = checksum;                    // Checksum
			TX_CMD = CMD_L4_OUTPUT;
			TX_CTR = 0;
			TX_Flag = true;
			L4_Output_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Blue, 7, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 7, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 7);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L1_ON_OFF()                                 // ǰe: L1 ON/OFF
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 6;                           // Packet Length
			TX_Packet[3] = CMD_L1_ON_OFF;               // Command
			TX_Packet[4] = L1_Set & SET_ON_OFF;         // L1 ON/OFF
			for (i = checksum = 0; i < 5; i++) checksum += TX_Packet[i];
			TX_Packet[5] = checksum;                    // Checksum
			TX_CMD = CMD_L1_ON_OFF;
			TX_CTR = 0;
			TX_Flag = true;
			L1_ON_OFF_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Green, 6, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 6, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 6);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L2_ON_OFF()                                 // ǰe: L2 ON/OFF
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 6;                           // Packet Length
			TX_Packet[3] = CMD_L2_ON_OFF;               // Command
			TX_Packet[4] = L2_Set & SET_ON_OFF;         // L2 ON/OFF
			for (i = checksum = 0; i < 5; i++) checksum += TX_Packet[i];
			TX_Packet[5] = checksum;                    // Checksum
			TX_CMD = CMD_L2_ON_OFF;
			TX_CTR = 0;
			TX_Flag = true;
			L2_ON_OFF_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Green, 6, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 6, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 6);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L3_ON_OFF()                                 // ǰe: L3 ON/OFF
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 6;                           // Packet Length
			TX_Packet[3] = CMD_L3_ON_OFF;               // Command
			TX_Packet[4] = L3_Set & SET_ON_OFF;         // L3 ON/OFF
			for (i = checksum = 0; i < 5; i++) checksum += TX_Packet[i];
			TX_Packet[5] = checksum;                    // Checksum
			TX_CMD = CMD_L3_ON_OFF;
			TX_CTR = 0;
			TX_Flag = true;
			L3_ON_OFF_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Green, 6, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 6, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 6);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	void TX_L4_ON_OFF()                                 // ǰe: L4 ON/OFF
	{
		Byte i, checksum;

		if (TX_Flag == false)
		{
			TX_Packet[0] = 0x4D;                        // Header 'M'
			TX_Packet[1] = 0x53;                        // Header 'S'
			TX_Packet[2] = 6;                           // Packet Length
			TX_Packet[3] = CMD_L4_ON_OFF;               // Command
			TX_Packet[4] = L4_Set & SET_ON_OFF;         // L4 ON/OFF
			for (i = checksum = 0; i < 5; i++) checksum += TX_Packet[i];
			TX_Packet[5] = checksum;                    // Checksum
			TX_CMD = CMD_L4_ON_OFF;
			TX_CTR = 0;
			TX_Flag = true;
			L4_ON_OFF_CHG = false;
		}

		if (TX_CTR == 0) Dsp_TX_Packet(Color::Green, 6, ++TX_CTR);
		else Dsp_TX_Packet(Color::Magenta, 6, ++TX_CTR);
		ACK_TO_CTR = Auto_CTR = 0;

		try
		{
			serialPort->Write(TX_Packet, 0, 6);
		}
		catch (Exception^ e)
		{
			Dsp_String(Color::Red, "Error: " + e->Message);
			SystemSounds::Exclamation->Play();
			COMPort_Disconnect();                       // Cu
		}
	}

	// Timer *******************************************************************

	private: System::Void timer_Tick(System::Object^  sender, System::EventArgs^  e)
	{
		if (PORT_Flag == true)                          // Cw}?
		{
			if (RX_Flag == true)                        // wʥ]?
			{
				TX_Flag = RX_Flag = false;
				TX_CTR = ACK_TO_CTR = 0;
				if (READ_Flag == false)
				{
					Update_Lx();                        // s (LxѼ)
					Update_ACK();                       // s (ACK)
					READ_Flag = true;
				}
				else Update_ACK();                      // s (ACK)
			}
			else
			{
				if (TX_Flag == true)                    // wǰeRO?
				{
					Check_RX_TO();                      // ˬdO
				}
				else
				{
					Check_TX_CMD();                     // ˬdǰeRO
				}
				Auto_Ask();                             // ۰ʸ߰
			}
			ERR_Flash();                                // ~ܰ{{
		}
	}

	void Check_RX_TO()                                  // ˬdO
	{
		if (++ACK_TO_CTR >= ACK_TO)
		{
			ACK_TO_CTR = 0;
			if (TX_CTR > 2)
			{
				Dsp_String(Color::Red, MODEL + "Oɥ^!");
				SystemSounds::Exclamation->Play();
				COMPort_Disconnect();                   // Cu
			}
			else
			{
				switch (TX_CMD)
				{
				case CMD_READ_DATA: TX_Read_Data(); break;  // ǰe: Read Data
				case CMD_SYNC_EN  : TX_SYNC_EN(); break;    // ǰe: SYNC Enable
				case CMD_L1_SET   : TX_L1_Set(); break;     // ǰe: L1 Set
				case CMD_L2_SET   : TX_L2_Set(); break;     // ǰe: L2 Set
				case CMD_L3_SET   : TX_L3_Set(); break;     // ǰe: L3 Set
				case CMD_L4_SET   : TX_L4_Set(); break;     // ǰe: L4 Set
				case CMD_L1_OUTPUT: TX_L1_Output(); break;  // ǰe: L1 Output
				case CMD_L2_OUTPUT: TX_L2_Output(); break;  // ǰe: L2 Output
				case CMD_L3_OUTPUT: TX_L3_Output(); break;  // ǰe: L3 Output
				case CMD_L4_OUTPUT: TX_L4_Output(); break;  // ǰe: L4 Output
				case CMD_L1_ON_OFF: TX_L1_ON_OFF(); break;  // ǰe: L1 ON/OFF
				case CMD_L2_ON_OFF: TX_L2_ON_OFF(); break;  // ǰe: L2 ON/OFF
				case CMD_L3_ON_OFF: TX_L3_ON_OFF(); break;  // ǰe: L3 ON/OFF
				case CMD_L4_ON_OFF: TX_L4_ON_OFF(); break;  // ǰe: L4 ON/OFF
				}
			}
		}
	}

	void Check_TX_CMD()                                 // ˬdǰeRO
	{
		if (SYNC_EN_CHG == true) { TX_SYNC_EN(); return; }
		if (L1_Set_CHG == true) { TX_L1_Set(); return; }
		if (L2_Set_CHG == true) { TX_L2_Set(); return; }
		if (L3_Set_CHG == true) { TX_L3_Set(); return; }
		if (L4_Set_CHG == true) { TX_L4_Set(); return; }
		if (L1_Output_CHG == true) { TX_L1_Output(); return; }
		if (L2_Output_CHG == true) { TX_L2_Output(); return; }
		if (L3_Output_CHG == true) { TX_L3_Output(); return; }
		if (L4_Output_CHG == true) { TX_L4_Output(); return; }
		if (L1_ON_OFF_CHG == true) { TX_L1_ON_OFF(); return; }
		if (L2_ON_OFF_CHG == true) { TX_L2_ON_OFF(); return; }
		if (L3_ON_OFF_CHG == true) { TX_L3_ON_OFF(); return; }
		if (L4_ON_OFF_CHG == true) { TX_L4_ON_OFF(); return; }
	}

	void Auto_Ask()                                     // ۰ʸ߰
	{
		if (++Auto_CTR >= AUTO_TMR) TX_Read_Data();     // ǰe: Read Data
		if (cbb_L1_MaxC->DroppedDown == true) Auto_CTR = 0;
		if (cbb_L2_MaxC->DroppedDown == true) Auto_CTR = 0;
		if (cbb_L3_MaxC->DroppedDown == true) Auto_CTR = 0;
		if (cbb_L4_MaxC->DroppedDown == true) Auto_CTR = 0;
		if (nud_L1_Output->Focused == true) Auto_CTR = 0;
		if (nud_L2_Output->Focused == true) Auto_CTR = 0;
		if (nud_L3_Output->Focused == true) Auto_CTR = 0;
		if (nud_L4_Output->Focused == true) Auto_CTR = 0;
		if (cbb_SYNC_EN->DroppedDown == true) Auto_CTR = 0;
	}

	void ERR_Flash()                                    // ~ܰ{{
	{
		if (Flash_CTR == 0)
		{
			if ((ACK_State & AS_L1_ERR) == AS_L1_ERR) lb_L1->BackColor = Color::Red;
			if ((ACK_State & AS_L2_ERR) == AS_L2_ERR) lb_L2->BackColor = Color::Red;
			if ((ACK_State & AS_L3_ERR) == AS_L3_ERR) lb_L3->BackColor = Color::Red;
			if ((ACK_State & AS_L4_ERR) == AS_L4_ERR) lb_L4->BackColor = Color::Red;
			if ((ACK_State & AS_PWR_ERR) == AS_PWR_ERR) lb_PWR_ERR->BackColor = Color::Red;
		}

		if (Flash_CTR == 5)
		{
			if ((ACK_State & AS_L1_ERR) == AS_L1_ERR) lb_L1->BackColor = Color::Black;
			if ((ACK_State & AS_L2_ERR) == AS_L2_ERR) lb_L2->BackColor = Color::Black;
			if ((ACK_State & AS_L3_ERR) == AS_L3_ERR) lb_L3->BackColor = Color::Black;
			if ((ACK_State & AS_L4_ERR) == AS_L4_ERR) lb_L4->BackColor = Color::Black;
			if ((ACK_State & AS_PWR_ERR) == AS_PWR_ERR) lb_PWR_ERR->BackColor = Color::Black;
		}

		if (++Flash_CTR > 9) Flash_CTR = 0;
	}

	void Update_Lx()                                    // s (LxѼ)
	{
		Dsp_RX_Packet(SystemColors::WindowText, 17);

		Byte v = 0;
		if ((RX_Packet[3] & AS_SYNC_EN1) == AS_SYNC_EN1) v |= 2;
		if ((RX_Packet[3] & AS_SYNC_EN0) == AS_SYNC_EN0) v |= 1;
		cbb_SYNC_EN->SelectedIndex = SYNC_EN = v;

		Update_L1();                                    // s (L1)
		Update_L2();                                    // s (L2)
		Update_L3();                                    // s (L3)
		Update_L4();                                    // s (L4)
	}

	void Update_L1()                                    // s (L1)
	{
		L1_Set = RX_Packet[4] & 0x33;
		if ((L1_Set & SET_ON_OFF) == SET_ON_OFF)        // L1: ON/OFF = ON ?
		{
			pn_L1_LED->BackColor = Color::Green;
			btn_L1->Text = "OFF";
		}
		else                                            // L1: ON/OFF = OFF
		{
			pn_L1_LED->BackColor = Color::Black;
			btn_L1->Text = "ON";
		}
		if ((L1_Set & SET_EXT_CTRL) == SET_EXT_CTRL)    // L1: EXT. ON/OFF Control = Checked ?
		{
			ckb_L1_EXT->Checked = true;
			pn_L1_LED->Visible = false;
			btn_L1->Visible = false;
		}
		else                                            // L1: EXT. ON/OFF Control = Unchecked
		{
			ckb_L1_EXT->Checked = false;
			pn_L1_LED->Visible = true;
			btn_L1->Visible = true;
		}

		cbb_L1_MaxC->SelectedIndex = (L1_Set >> 4) & 0x03;
		int MaxC = MaxCurrent[cbb_L1_MaxC->SelectedIndex];

		int highbyte = RX_Packet[5];
		highbyte <<= 8;
		L1_Output = highbyte | RX_Packet[6];

		nud_L1_Output->Maximum = MaxC;
		tkb_L1_Output->Maximum = MaxC;
		nud_L1_Output->Value = L1_Output;
		tkb_L1_Output->Value = L1_Output;
		tkb_L1_Output->TickFrequency = MaxC / 10;
		lb_L1_PCV->Text = String::Format("{0:F1}", (float)(L1_Output * 100) / MaxC);
	}

	void Update_L2()                                    // s (L2)
	{
		L2_Set = RX_Packet[7] & 0x33;
		if ((L2_Set & SET_ON_OFF) == SET_ON_OFF)        // L2: ON/OFF = ON ?
		{
			pn_L2_LED->BackColor = Color::Green;
			btn_L2->Text = "OFF";
		}
		else                                            // L2: ON/OFF = OFF
		{
			pn_L2_LED->BackColor = Color::Black;
			btn_L2->Text = "ON";
		}
		if ((L2_Set & SET_EXT_CTRL) == SET_EXT_CTRL)    // L2: EXT. ON/OFF Control = Checked ?
		{
			ckb_L2_EXT->Checked = true;
			pn_L2_LED->Visible = false;
			btn_L2->Visible = false;
		}
		else                                            // L2: EXT. ON/OFF Control = Unchecked
		{
			ckb_L2_EXT->Checked = false;
			pn_L2_LED->Visible = true;
			btn_L2->Visible = true;
		}

		cbb_L2_MaxC->SelectedIndex = (L2_Set >> 4) & 0x03;
		int MaxC = MaxCurrent[cbb_L2_MaxC->SelectedIndex];

		int highbyte = RX_Packet[8];
		highbyte <<= 8;
		L2_Output = highbyte | RX_Packet[9];

		nud_L2_Output->Maximum = MaxC;
		tkb_L2_Output->Maximum = MaxC;
		nud_L2_Output->Value = L2_Output;
		tkb_L2_Output->Value = L2_Output;
		tkb_L2_Output->TickFrequency = MaxC / 10;
		lb_L2_PCV->Text = String::Format("{0:F1}", (float)(L2_Output * 100) / MaxC);
	}

	void Update_L3()                                    // s (L3)
	{
		L3_Set = RX_Packet[10] & 0x33;
		if ((L3_Set & SET_ON_OFF) == SET_ON_OFF)        // L3: ON/OFF = ON ?
		{
			pn_L3_LED->BackColor = Color::Green;
			btn_L3->Text = "OFF";
		}
		else                                            // L3: ON/OFF = OFF
		{
			pn_L3_LED->BackColor = Color::Black;
			btn_L3->Text = "ON";
		}
		if ((L3_Set & SET_EXT_CTRL) == SET_EXT_CTRL)     // L3: EXT. ON/OFF Control = Checked ?
		{
			ckb_L3_EXT->Checked = true;
			pn_L3_LED->Visible = false;
			btn_L3->Visible = false;
		}
		else                                             // L3: EXT. ON/OFF Control = Unchecked
		{
			ckb_L3_EXT->Checked = false;
			pn_L3_LED->Visible = true;
			btn_L3->Visible = true;
		}

		cbb_L3_MaxC->SelectedIndex = (L3_Set >> 4) & 0x03;
		int MaxC = MaxCurrent[cbb_L3_MaxC->SelectedIndex];

		int highbyte = RX_Packet[11];
		highbyte <<= 8;
		L3_Output = highbyte | RX_Packet[12];

		nud_L3_Output->Maximum = MaxC;
		tkb_L3_Output->Maximum = MaxC;
		nud_L3_Output->Value = L3_Output;
		tkb_L3_Output->Value = L3_Output;
		tkb_L3_Output->TickFrequency = MaxC / 10;
		lb_L3_PCV->Text = String::Format("{0:F1}", (float)(L3_Output * 100) / MaxC);
	}

	void Update_L4()                                    // s (L4)
	{
		L4_Set = RX_Packet[13] & 0x33;
		if ((L4_Set & SET_ON_OFF) == SET_ON_OFF)        // L4: ON/OFF = ON ?
		{
			pn_L4_LED->BackColor = Color::Green;
			btn_L4->Text = "OFF";
		}
		else                                            // L4: ON/OFF = OFF
		{
			pn_L4_LED->BackColor = Color::Black;
			btn_L4->Text = "ON";
		}
		if ((L4_Set & SET_EXT_CTRL) == SET_EXT_CTRL)    // L4: EXT. ON/OFF Control = Checked ?
		{
			ckb_L4_EXT->Checked = true;
			pn_L4_LED->Visible = false;
			btn_L4->Visible = false;
		}
		else                                            // L4: EXT. ON/OFF Control = Unchecked
		{
			ckb_L4_EXT->Checked = false;
			pn_L4_LED->Visible = true;
			btn_L4->Visible = true;
		}

		cbb_L4_MaxC->SelectedIndex = (L4_Set >> 4) & 0x03;
		int MaxC = MaxCurrent[cbb_L4_MaxC->SelectedIndex];

		int highbyte = RX_Packet[14];
		highbyte <<= 8;
		L4_Output = highbyte | RX_Packet[15];

		nud_L4_Output->Maximum = MaxC;
		tkb_L4_Output->Maximum = MaxC;
		nud_L4_Output->Value = L4_Output;
		tkb_L4_Output->Value = L4_Output;
		tkb_L4_Output->TickFrequency = MaxC / 10;
		lb_L4_PCV->Text = String::Format("{0:F1}", (float)(L4_Output * 100) / MaxC);
	}

	void Update_ACK()                                   // s (ACK)
	{
		if (RX_Length == 5) Dsp_RX_Packet(SystemColors::WindowText, 5);
		ACK_State = RX_Packet[3];
		if (ACK_State & 0x9F)                           // AS_FAILED | AS_PWR_ERR | AS_L4_ERR | AS_L3_ERR | AS_L2_ERR | AS_L1_ERR
		{
			SystemSounds::Exclamation->Play();
		}

		if ((ACK_State & AS_FAILED) == AS_FAILED) Dsp_String(Color::Red, MODEL + "RO楢!");

		if ((ACK_State & AS_L1_ERR) == AS_L1_ERR)
		{
			lb_L1->Text = "L1 Error";
			Dsp_String(Color::Red, MODEL + "L1~!");
		}
		else
		{
			lb_L1->Text = "L1";
			lb_L1->BackColor = Color::Black;
		}

		if ((ACK_State & AS_L2_ERR) == AS_L2_ERR)
		{
			lb_L2->Text = "L2 Error";
			Dsp_String(Color::Red, MODEL + "L2~!");
		}
		else
		{
			lb_L2->Text = "L2";
			lb_L2->BackColor = Color::Black;
		}

		if ((ACK_State & AS_L3_ERR) == AS_L3_ERR)
		{
			lb_L3->Text = "L3 Error";
			Dsp_String(Color::Red, MODEL + "L3~!");
		}
		else
		{
			lb_L3->Text = "L3";
			lb_L3->BackColor = Color::Black;
		}

		if ((ACK_State & AS_L4_ERR) == AS_L4_ERR)
		{
			lb_L4->Text = "L4 Error";
			Dsp_String(Color::Red, MODEL + "L4~!");
		}
		else
		{
			lb_L4->Text = "L4";
			lb_L4->BackColor = Color::Black;
		}

		if ((ACK_State & AS_PWR_ERR) == AS_PWR_ERR)
		{
			lb_PWR_ERR->ForeColor = Color::White;
			Dsp_String(Color::Red, MODEL + "qLC!");
			gpb_ON_OFF->Enabled = false;
			gpb_L1->Enabled = false;
			gpb_L2->Enabled = false;
			gpb_L3->Enabled = false;
			gpb_L4->Enabled = false;
		}
		else
		{
			lb_PWR_ERR->ForeColor = Color::Gray;
			lb_PWR_ERR->BackColor = Color::Black;
			gpb_ON_OFF->Enabled = true;
			if (!(ACK_State & AS_L1_ERR)) gpb_L1->Enabled = true;
			else gpb_L1->Enabled = false;
			if (!(ACK_State & AS_L2_ERR)) gpb_L2->Enabled = true;
			else gpb_L2->Enabled = false;
			if (!(ACK_State & AS_L3_ERR)) gpb_L3->Enabled = true;
			else gpb_L3->Enabled = false;
			if (!(ACK_State & AS_L4_ERR)) gpb_L4->Enabled = true;
			else gpb_L4->Enabled = false;
		}
	}
};
}
